// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from kompass_interfaces:action/MotionRecording.idl
// generated code does not contain a copyright notice

#ifndef KOMPASS_INTERFACES__ACTION__DETAIL__MOTION_RECORDING__BUILDER_HPP_
#define KOMPASS_INTERFACES__ACTION__DETAIL__MOTION_RECORDING__BUILDER_HPP_

#include <algorithm>
#include <utility>

#include "kompass_interfaces/action/detail/motion_recording__struct.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


namespace kompass_interfaces
{

namespace action
{

namespace builder
{

class Init_MotionRecording_Goal_csv_file_name
{
public:
  explicit Init_MotionRecording_Goal_csv_file_name(::kompass_interfaces::action::MotionRecording_Goal & msg)
  : msg_(msg)
  {}
  ::kompass_interfaces::action::MotionRecording_Goal csv_file_name(::kompass_interfaces::action::MotionRecording_Goal::_csv_file_name_type arg)
  {
    msg_.csv_file_name = std::move(arg);
    return std::move(msg_);
  }

private:
  ::kompass_interfaces::action::MotionRecording_Goal msg_;
};

class Init_MotionRecording_Goal_csv_file_location
{
public:
  explicit Init_MotionRecording_Goal_csv_file_location(::kompass_interfaces::action::MotionRecording_Goal & msg)
  : msg_(msg)
  {}
  Init_MotionRecording_Goal_csv_file_name csv_file_location(::kompass_interfaces::action::MotionRecording_Goal::_csv_file_location_type arg)
  {
    msg_.csv_file_location = std::move(arg);
    return Init_MotionRecording_Goal_csv_file_name(msg_);
  }

private:
  ::kompass_interfaces::action::MotionRecording_Goal msg_;
};

class Init_MotionRecording_Goal_recording_time_step_secs
{
public:
  explicit Init_MotionRecording_Goal_recording_time_step_secs(::kompass_interfaces::action::MotionRecording_Goal & msg)
  : msg_(msg)
  {}
  Init_MotionRecording_Goal_csv_file_location recording_time_step_secs(::kompass_interfaces::action::MotionRecording_Goal::_recording_time_step_secs_type arg)
  {
    msg_.recording_time_step_secs = std::move(arg);
    return Init_MotionRecording_Goal_csv_file_location(msg_);
  }

private:
  ::kompass_interfaces::action::MotionRecording_Goal msg_;
};

class Init_MotionRecording_Goal_recording_period_secs
{
public:
  Init_MotionRecording_Goal_recording_period_secs()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_MotionRecording_Goal_recording_time_step_secs recording_period_secs(::kompass_interfaces::action::MotionRecording_Goal::_recording_period_secs_type arg)
  {
    msg_.recording_period_secs = std::move(arg);
    return Init_MotionRecording_Goal_recording_time_step_secs(msg_);
  }

private:
  ::kompass_interfaces::action::MotionRecording_Goal msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::kompass_interfaces::action::MotionRecording_Goal>()
{
  return kompass_interfaces::action::builder::Init_MotionRecording_Goal_recording_period_secs();
}

}  // namespace kompass_interfaces


namespace kompass_interfaces
{

namespace action
{

namespace builder
{

class Init_MotionRecording_Result_message
{
public:
  explicit Init_MotionRecording_Result_message(::kompass_interfaces::action::MotionRecording_Result & msg)
  : msg_(msg)
  {}
  ::kompass_interfaces::action::MotionRecording_Result message(::kompass_interfaces::action::MotionRecording_Result::_message_type arg)
  {
    msg_.message = std::move(arg);
    return std::move(msg_);
  }

private:
  ::kompass_interfaces::action::MotionRecording_Result msg_;
};

class Init_MotionRecording_Result_recording_done
{
public:
  Init_MotionRecording_Result_recording_done()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_MotionRecording_Result_message recording_done(::kompass_interfaces::action::MotionRecording_Result::_recording_done_type arg)
  {
    msg_.recording_done = std::move(arg);
    return Init_MotionRecording_Result_message(msg_);
  }

private:
  ::kompass_interfaces::action::MotionRecording_Result msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::kompass_interfaces::action::MotionRecording_Result>()
{
  return kompass_interfaces::action::builder::Init_MotionRecording_Result_recording_done();
}

}  // namespace kompass_interfaces


namespace kompass_interfaces
{

namespace action
{

namespace builder
{

class Init_MotionRecording_Feedback_cmd
{
public:
  explicit Init_MotionRecording_Feedback_cmd(::kompass_interfaces::action::MotionRecording_Feedback & msg)
  : msg_(msg)
  {}
  ::kompass_interfaces::action::MotionRecording_Feedback cmd(::kompass_interfaces::action::MotionRecording_Feedback::_cmd_type arg)
  {
    msg_.cmd = std::move(arg);
    return std::move(msg_);
  }

private:
  ::kompass_interfaces::action::MotionRecording_Feedback msg_;
};

class Init_MotionRecording_Feedback_heading
{
public:
  explicit Init_MotionRecording_Feedback_heading(::kompass_interfaces::action::MotionRecording_Feedback & msg)
  : msg_(msg)
  {}
  Init_MotionRecording_Feedback_cmd heading(::kompass_interfaces::action::MotionRecording_Feedback::_heading_type arg)
  {
    msg_.heading = std::move(arg);
    return Init_MotionRecording_Feedback_cmd(msg_);
  }

private:
  ::kompass_interfaces::action::MotionRecording_Feedback msg_;
};

class Init_MotionRecording_Feedback_position
{
public:
  Init_MotionRecording_Feedback_position()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_MotionRecording_Feedback_heading position(::kompass_interfaces::action::MotionRecording_Feedback::_position_type arg)
  {
    msg_.position = std::move(arg);
    return Init_MotionRecording_Feedback_heading(msg_);
  }

private:
  ::kompass_interfaces::action::MotionRecording_Feedback msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::kompass_interfaces::action::MotionRecording_Feedback>()
{
  return kompass_interfaces::action::builder::Init_MotionRecording_Feedback_position();
}

}  // namespace kompass_interfaces


namespace kompass_interfaces
{

namespace action
{

namespace builder
{

class Init_MotionRecording_SendGoal_Request_goal
{
public:
  explicit Init_MotionRecording_SendGoal_Request_goal(::kompass_interfaces::action::MotionRecording_SendGoal_Request & msg)
  : msg_(msg)
  {}
  ::kompass_interfaces::action::MotionRecording_SendGoal_Request goal(::kompass_interfaces::action::MotionRecording_SendGoal_Request::_goal_type arg)
  {
    msg_.goal = std::move(arg);
    return std::move(msg_);
  }

private:
  ::kompass_interfaces::action::MotionRecording_SendGoal_Request msg_;
};

class Init_MotionRecording_SendGoal_Request_goal_id
{
public:
  Init_MotionRecording_SendGoal_Request_goal_id()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_MotionRecording_SendGoal_Request_goal goal_id(::kompass_interfaces::action::MotionRecording_SendGoal_Request::_goal_id_type arg)
  {
    msg_.goal_id = std::move(arg);
    return Init_MotionRecording_SendGoal_Request_goal(msg_);
  }

private:
  ::kompass_interfaces::action::MotionRecording_SendGoal_Request msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::kompass_interfaces::action::MotionRecording_SendGoal_Request>()
{
  return kompass_interfaces::action::builder::Init_MotionRecording_SendGoal_Request_goal_id();
}

}  // namespace kompass_interfaces


namespace kompass_interfaces
{

namespace action
{

namespace builder
{

class Init_MotionRecording_SendGoal_Response_stamp
{
public:
  explicit Init_MotionRecording_SendGoal_Response_stamp(::kompass_interfaces::action::MotionRecording_SendGoal_Response & msg)
  : msg_(msg)
  {}
  ::kompass_interfaces::action::MotionRecording_SendGoal_Response stamp(::kompass_interfaces::action::MotionRecording_SendGoal_Response::_stamp_type arg)
  {
    msg_.stamp = std::move(arg);
    return std::move(msg_);
  }

private:
  ::kompass_interfaces::action::MotionRecording_SendGoal_Response msg_;
};

class Init_MotionRecording_SendGoal_Response_accepted
{
public:
  Init_MotionRecording_SendGoal_Response_accepted()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_MotionRecording_SendGoal_Response_stamp accepted(::kompass_interfaces::action::MotionRecording_SendGoal_Response::_accepted_type arg)
  {
    msg_.accepted = std::move(arg);
    return Init_MotionRecording_SendGoal_Response_stamp(msg_);
  }

private:
  ::kompass_interfaces::action::MotionRecording_SendGoal_Response msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::kompass_interfaces::action::MotionRecording_SendGoal_Response>()
{
  return kompass_interfaces::action::builder::Init_MotionRecording_SendGoal_Response_accepted();
}

}  // namespace kompass_interfaces


namespace kompass_interfaces
{

namespace action
{

namespace builder
{

class Init_MotionRecording_GetResult_Request_goal_id
{
public:
  Init_MotionRecording_GetResult_Request_goal_id()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  ::kompass_interfaces::action::MotionRecording_GetResult_Request goal_id(::kompass_interfaces::action::MotionRecording_GetResult_Request::_goal_id_type arg)
  {
    msg_.goal_id = std::move(arg);
    return std::move(msg_);
  }

private:
  ::kompass_interfaces::action::MotionRecording_GetResult_Request msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::kompass_interfaces::action::MotionRecording_GetResult_Request>()
{
  return kompass_interfaces::action::builder::Init_MotionRecording_GetResult_Request_goal_id();
}

}  // namespace kompass_interfaces


namespace kompass_interfaces
{

namespace action
{

namespace builder
{

class Init_MotionRecording_GetResult_Response_result
{
public:
  explicit Init_MotionRecording_GetResult_Response_result(::kompass_interfaces::action::MotionRecording_GetResult_Response & msg)
  : msg_(msg)
  {}
  ::kompass_interfaces::action::MotionRecording_GetResult_Response result(::kompass_interfaces::action::MotionRecording_GetResult_Response::_result_type arg)
  {
    msg_.result = std::move(arg);
    return std::move(msg_);
  }

private:
  ::kompass_interfaces::action::MotionRecording_GetResult_Response msg_;
};

class Init_MotionRecording_GetResult_Response_status
{
public:
  Init_MotionRecording_GetResult_Response_status()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_MotionRecording_GetResult_Response_result status(::kompass_interfaces::action::MotionRecording_GetResult_Response::_status_type arg)
  {
    msg_.status = std::move(arg);
    return Init_MotionRecording_GetResult_Response_result(msg_);
  }

private:
  ::kompass_interfaces::action::MotionRecording_GetResult_Response msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::kompass_interfaces::action::MotionRecording_GetResult_Response>()
{
  return kompass_interfaces::action::builder::Init_MotionRecording_GetResult_Response_status();
}

}  // namespace kompass_interfaces


namespace kompass_interfaces
{

namespace action
{

namespace builder
{

class Init_MotionRecording_FeedbackMessage_feedback
{
public:
  explicit Init_MotionRecording_FeedbackMessage_feedback(::kompass_interfaces::action::MotionRecording_FeedbackMessage & msg)
  : msg_(msg)
  {}
  ::kompass_interfaces::action::MotionRecording_FeedbackMessage feedback(::kompass_interfaces::action::MotionRecording_FeedbackMessage::_feedback_type arg)
  {
    msg_.feedback = std::move(arg);
    return std::move(msg_);
  }

private:
  ::kompass_interfaces::action::MotionRecording_FeedbackMessage msg_;
};

class Init_MotionRecording_FeedbackMessage_goal_id
{
public:
  Init_MotionRecording_FeedbackMessage_goal_id()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_MotionRecording_FeedbackMessage_feedback goal_id(::kompass_interfaces::action::MotionRecording_FeedbackMessage::_goal_id_type arg)
  {
    msg_.goal_id = std::move(arg);
    return Init_MotionRecording_FeedbackMessage_feedback(msg_);
  }

private:
  ::kompass_interfaces::action::MotionRecording_FeedbackMessage msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::kompass_interfaces::action::MotionRecording_FeedbackMessage>()
{
  return kompass_interfaces::action::builder::Init_MotionRecording_FeedbackMessage_goal_id();
}

}  // namespace kompass_interfaces

#endif  // KOMPASS_INTERFACES__ACTION__DETAIL__MOTION_RECORDING__BUILDER_HPP_
