// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from kompass_interfaces:action/MotionRecording.idl
// generated code does not contain a copyright notice

#ifndef KOMPASS_INTERFACES__ACTION__DETAIL__MOTION_RECORDING__STRUCT_H_
#define KOMPASS_INTERFACES__ACTION__DETAIL__MOTION_RECORDING__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'csv_file_location'
// Member 'csv_file_name'
#include "rosidl_runtime_c/string.h"

/// Struct defined in action/MotionRecording in the package kompass_interfaces.
typedef struct kompass_interfaces__action__MotionRecording_Goal
{
  double recording_period_secs;
  double recording_time_step_secs;
  rosidl_runtime_c__String csv_file_location;
  rosidl_runtime_c__String csv_file_name;
} kompass_interfaces__action__MotionRecording_Goal;

// Struct for a sequence of kompass_interfaces__action__MotionRecording_Goal.
typedef struct kompass_interfaces__action__MotionRecording_Goal__Sequence
{
  kompass_interfaces__action__MotionRecording_Goal * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} kompass_interfaces__action__MotionRecording_Goal__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'message'
// already included above
// #include "rosidl_runtime_c/string.h"

/// Struct defined in action/MotionRecording in the package kompass_interfaces.
typedef struct kompass_interfaces__action__MotionRecording_Result
{
  bool recording_done;
  rosidl_runtime_c__String message;
} kompass_interfaces__action__MotionRecording_Result;

// Struct for a sequence of kompass_interfaces__action__MotionRecording_Result.
typedef struct kompass_interfaces__action__MotionRecording_Result__Sequence
{
  kompass_interfaces__action__MotionRecording_Result * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} kompass_interfaces__action__MotionRecording_Result__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'position'
// Member 'cmd'
#include "geometry_msgs/msg/detail/vector3__struct.h"

/// Struct defined in action/MotionRecording in the package kompass_interfaces.
typedef struct kompass_interfaces__action__MotionRecording_Feedback
{
  geometry_msgs__msg__Vector3 position;
  double heading;
  geometry_msgs__msg__Vector3 cmd;
} kompass_interfaces__action__MotionRecording_Feedback;

// Struct for a sequence of kompass_interfaces__action__MotionRecording_Feedback.
typedef struct kompass_interfaces__action__MotionRecording_Feedback__Sequence
{
  kompass_interfaces__action__MotionRecording_Feedback * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} kompass_interfaces__action__MotionRecording_Feedback__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'goal_id'
#include "unique_identifier_msgs/msg/detail/uuid__struct.h"
// Member 'goal'
#include "kompass_interfaces/action/detail/motion_recording__struct.h"

/// Struct defined in action/MotionRecording in the package kompass_interfaces.
typedef struct kompass_interfaces__action__MotionRecording_SendGoal_Request
{
  unique_identifier_msgs__msg__UUID goal_id;
  kompass_interfaces__action__MotionRecording_Goal goal;
} kompass_interfaces__action__MotionRecording_SendGoal_Request;

// Struct for a sequence of kompass_interfaces__action__MotionRecording_SendGoal_Request.
typedef struct kompass_interfaces__action__MotionRecording_SendGoal_Request__Sequence
{
  kompass_interfaces__action__MotionRecording_SendGoal_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} kompass_interfaces__action__MotionRecording_SendGoal_Request__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__struct.h"

/// Struct defined in action/MotionRecording in the package kompass_interfaces.
typedef struct kompass_interfaces__action__MotionRecording_SendGoal_Response
{
  bool accepted;
  builtin_interfaces__msg__Time stamp;
} kompass_interfaces__action__MotionRecording_SendGoal_Response;

// Struct for a sequence of kompass_interfaces__action__MotionRecording_SendGoal_Response.
typedef struct kompass_interfaces__action__MotionRecording_SendGoal_Response__Sequence
{
  kompass_interfaces__action__MotionRecording_SendGoal_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} kompass_interfaces__action__MotionRecording_SendGoal_Response__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__struct.h"

/// Struct defined in action/MotionRecording in the package kompass_interfaces.
typedef struct kompass_interfaces__action__MotionRecording_GetResult_Request
{
  unique_identifier_msgs__msg__UUID goal_id;
} kompass_interfaces__action__MotionRecording_GetResult_Request;

// Struct for a sequence of kompass_interfaces__action__MotionRecording_GetResult_Request.
typedef struct kompass_interfaces__action__MotionRecording_GetResult_Request__Sequence
{
  kompass_interfaces__action__MotionRecording_GetResult_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} kompass_interfaces__action__MotionRecording_GetResult_Request__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'result'
// already included above
// #include "kompass_interfaces/action/detail/motion_recording__struct.h"

/// Struct defined in action/MotionRecording in the package kompass_interfaces.
typedef struct kompass_interfaces__action__MotionRecording_GetResult_Response
{
  int8_t status;
  kompass_interfaces__action__MotionRecording_Result result;
} kompass_interfaces__action__MotionRecording_GetResult_Response;

// Struct for a sequence of kompass_interfaces__action__MotionRecording_GetResult_Response.
typedef struct kompass_interfaces__action__MotionRecording_GetResult_Response__Sequence
{
  kompass_interfaces__action__MotionRecording_GetResult_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} kompass_interfaces__action__MotionRecording_GetResult_Response__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__struct.h"
// Member 'feedback'
// already included above
// #include "kompass_interfaces/action/detail/motion_recording__struct.h"

/// Struct defined in action/MotionRecording in the package kompass_interfaces.
typedef struct kompass_interfaces__action__MotionRecording_FeedbackMessage
{
  unique_identifier_msgs__msg__UUID goal_id;
  kompass_interfaces__action__MotionRecording_Feedback feedback;
} kompass_interfaces__action__MotionRecording_FeedbackMessage;

// Struct for a sequence of kompass_interfaces__action__MotionRecording_FeedbackMessage.
typedef struct kompass_interfaces__action__MotionRecording_FeedbackMessage__Sequence
{
  kompass_interfaces__action__MotionRecording_FeedbackMessage * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} kompass_interfaces__action__MotionRecording_FeedbackMessage__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // KOMPASS_INTERFACES__ACTION__DETAIL__MOTION_RECORDING__STRUCT_H_
