// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from kompass_interfaces:action/MotionRecording.idl
// generated code does not contain a copyright notice

#ifndef KOMPASS_INTERFACES__ACTION__DETAIL__MOTION_RECORDING__TRAITS_HPP_
#define KOMPASS_INTERFACES__ACTION__DETAIL__MOTION_RECORDING__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "kompass_interfaces/action/detail/motion_recording__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace kompass_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const MotionRecording_Goal & msg,
  std::ostream & out)
{
  out << "{";
  // member: recording_period_secs
  {
    out << "recording_period_secs: ";
    rosidl_generator_traits::value_to_yaml(msg.recording_period_secs, out);
    out << ", ";
  }

  // member: recording_time_step_secs
  {
    out << "recording_time_step_secs: ";
    rosidl_generator_traits::value_to_yaml(msg.recording_time_step_secs, out);
    out << ", ";
  }

  // member: csv_file_location
  {
    out << "csv_file_location: ";
    rosidl_generator_traits::value_to_yaml(msg.csv_file_location, out);
    out << ", ";
  }

  // member: csv_file_name
  {
    out << "csv_file_name: ";
    rosidl_generator_traits::value_to_yaml(msg.csv_file_name, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const MotionRecording_Goal & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: recording_period_secs
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "recording_period_secs: ";
    rosidl_generator_traits::value_to_yaml(msg.recording_period_secs, out);
    out << "\n";
  }

  // member: recording_time_step_secs
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "recording_time_step_secs: ";
    rosidl_generator_traits::value_to_yaml(msg.recording_time_step_secs, out);
    out << "\n";
  }

  // member: csv_file_location
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "csv_file_location: ";
    rosidl_generator_traits::value_to_yaml(msg.csv_file_location, out);
    out << "\n";
  }

  // member: csv_file_name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "csv_file_name: ";
    rosidl_generator_traits::value_to_yaml(msg.csv_file_name, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const MotionRecording_Goal & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace kompass_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use kompass_interfaces::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const kompass_interfaces::action::MotionRecording_Goal & msg,
  std::ostream & out, size_t indentation = 0)
{
  kompass_interfaces::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use kompass_interfaces::action::to_yaml() instead")]]
inline std::string to_yaml(const kompass_interfaces::action::MotionRecording_Goal & msg)
{
  return kompass_interfaces::action::to_yaml(msg);
}

template<>
inline const char * data_type<kompass_interfaces::action::MotionRecording_Goal>()
{
  return "kompass_interfaces::action::MotionRecording_Goal";
}

template<>
inline const char * name<kompass_interfaces::action::MotionRecording_Goal>()
{
  return "kompass_interfaces/action/MotionRecording_Goal";
}

template<>
struct has_fixed_size<kompass_interfaces::action::MotionRecording_Goal>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<kompass_interfaces::action::MotionRecording_Goal>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<kompass_interfaces::action::MotionRecording_Goal>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace kompass_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const MotionRecording_Result & msg,
  std::ostream & out)
{
  out << "{";
  // member: recording_done
  {
    out << "recording_done: ";
    rosidl_generator_traits::value_to_yaml(msg.recording_done, out);
    out << ", ";
  }

  // member: message
  {
    out << "message: ";
    rosidl_generator_traits::value_to_yaml(msg.message, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const MotionRecording_Result & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: recording_done
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "recording_done: ";
    rosidl_generator_traits::value_to_yaml(msg.recording_done, out);
    out << "\n";
  }

  // member: message
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "message: ";
    rosidl_generator_traits::value_to_yaml(msg.message, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const MotionRecording_Result & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace kompass_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use kompass_interfaces::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const kompass_interfaces::action::MotionRecording_Result & msg,
  std::ostream & out, size_t indentation = 0)
{
  kompass_interfaces::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use kompass_interfaces::action::to_yaml() instead")]]
inline std::string to_yaml(const kompass_interfaces::action::MotionRecording_Result & msg)
{
  return kompass_interfaces::action::to_yaml(msg);
}

template<>
inline const char * data_type<kompass_interfaces::action::MotionRecording_Result>()
{
  return "kompass_interfaces::action::MotionRecording_Result";
}

template<>
inline const char * name<kompass_interfaces::action::MotionRecording_Result>()
{
  return "kompass_interfaces/action/MotionRecording_Result";
}

template<>
struct has_fixed_size<kompass_interfaces::action::MotionRecording_Result>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<kompass_interfaces::action::MotionRecording_Result>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<kompass_interfaces::action::MotionRecording_Result>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'position'
// Member 'cmd'
#include "geometry_msgs/msg/detail/vector3__traits.hpp"

namespace kompass_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const MotionRecording_Feedback & msg,
  std::ostream & out)
{
  out << "{";
  // member: position
  {
    out << "position: ";
    to_flow_style_yaml(msg.position, out);
    out << ", ";
  }

  // member: heading
  {
    out << "heading: ";
    rosidl_generator_traits::value_to_yaml(msg.heading, out);
    out << ", ";
  }

  // member: cmd
  {
    out << "cmd: ";
    to_flow_style_yaml(msg.cmd, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const MotionRecording_Feedback & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: position
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "position:\n";
    to_block_style_yaml(msg.position, out, indentation + 2);
  }

  // member: heading
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "heading: ";
    rosidl_generator_traits::value_to_yaml(msg.heading, out);
    out << "\n";
  }

  // member: cmd
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "cmd:\n";
    to_block_style_yaml(msg.cmd, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const MotionRecording_Feedback & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace kompass_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use kompass_interfaces::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const kompass_interfaces::action::MotionRecording_Feedback & msg,
  std::ostream & out, size_t indentation = 0)
{
  kompass_interfaces::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use kompass_interfaces::action::to_yaml() instead")]]
inline std::string to_yaml(const kompass_interfaces::action::MotionRecording_Feedback & msg)
{
  return kompass_interfaces::action::to_yaml(msg);
}

template<>
inline const char * data_type<kompass_interfaces::action::MotionRecording_Feedback>()
{
  return "kompass_interfaces::action::MotionRecording_Feedback";
}

template<>
inline const char * name<kompass_interfaces::action::MotionRecording_Feedback>()
{
  return "kompass_interfaces/action/MotionRecording_Feedback";
}

template<>
struct has_fixed_size<kompass_interfaces::action::MotionRecording_Feedback>
  : std::integral_constant<bool, has_fixed_size<geometry_msgs::msg::Vector3>::value> {};

template<>
struct has_bounded_size<kompass_interfaces::action::MotionRecording_Feedback>
  : std::integral_constant<bool, has_bounded_size<geometry_msgs::msg::Vector3>::value> {};

template<>
struct is_message<kompass_interfaces::action::MotionRecording_Feedback>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'goal_id'
#include "unique_identifier_msgs/msg/detail/uuid__traits.hpp"
// Member 'goal'
#include "kompass_interfaces/action/detail/motion_recording__traits.hpp"

namespace kompass_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const MotionRecording_SendGoal_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: goal_id
  {
    out << "goal_id: ";
    to_flow_style_yaml(msg.goal_id, out);
    out << ", ";
  }

  // member: goal
  {
    out << "goal: ";
    to_flow_style_yaml(msg.goal, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const MotionRecording_SendGoal_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: goal_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal_id:\n";
    to_block_style_yaml(msg.goal_id, out, indentation + 2);
  }

  // member: goal
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal:\n";
    to_block_style_yaml(msg.goal, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const MotionRecording_SendGoal_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace kompass_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use kompass_interfaces::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const kompass_interfaces::action::MotionRecording_SendGoal_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  kompass_interfaces::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use kompass_interfaces::action::to_yaml() instead")]]
inline std::string to_yaml(const kompass_interfaces::action::MotionRecording_SendGoal_Request & msg)
{
  return kompass_interfaces::action::to_yaml(msg);
}

template<>
inline const char * data_type<kompass_interfaces::action::MotionRecording_SendGoal_Request>()
{
  return "kompass_interfaces::action::MotionRecording_SendGoal_Request";
}

template<>
inline const char * name<kompass_interfaces::action::MotionRecording_SendGoal_Request>()
{
  return "kompass_interfaces/action/MotionRecording_SendGoal_Request";
}

template<>
struct has_fixed_size<kompass_interfaces::action::MotionRecording_SendGoal_Request>
  : std::integral_constant<bool, has_fixed_size<kompass_interfaces::action::MotionRecording_Goal>::value && has_fixed_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct has_bounded_size<kompass_interfaces::action::MotionRecording_SendGoal_Request>
  : std::integral_constant<bool, has_bounded_size<kompass_interfaces::action::MotionRecording_Goal>::value && has_bounded_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct is_message<kompass_interfaces::action::MotionRecording_SendGoal_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__traits.hpp"

namespace kompass_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const MotionRecording_SendGoal_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: accepted
  {
    out << "accepted: ";
    rosidl_generator_traits::value_to_yaml(msg.accepted, out);
    out << ", ";
  }

  // member: stamp
  {
    out << "stamp: ";
    to_flow_style_yaml(msg.stamp, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const MotionRecording_SendGoal_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: accepted
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "accepted: ";
    rosidl_generator_traits::value_to_yaml(msg.accepted, out);
    out << "\n";
  }

  // member: stamp
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "stamp:\n";
    to_block_style_yaml(msg.stamp, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const MotionRecording_SendGoal_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace kompass_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use kompass_interfaces::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const kompass_interfaces::action::MotionRecording_SendGoal_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  kompass_interfaces::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use kompass_interfaces::action::to_yaml() instead")]]
inline std::string to_yaml(const kompass_interfaces::action::MotionRecording_SendGoal_Response & msg)
{
  return kompass_interfaces::action::to_yaml(msg);
}

template<>
inline const char * data_type<kompass_interfaces::action::MotionRecording_SendGoal_Response>()
{
  return "kompass_interfaces::action::MotionRecording_SendGoal_Response";
}

template<>
inline const char * name<kompass_interfaces::action::MotionRecording_SendGoal_Response>()
{
  return "kompass_interfaces/action/MotionRecording_SendGoal_Response";
}

template<>
struct has_fixed_size<kompass_interfaces::action::MotionRecording_SendGoal_Response>
  : std::integral_constant<bool, has_fixed_size<builtin_interfaces::msg::Time>::value> {};

template<>
struct has_bounded_size<kompass_interfaces::action::MotionRecording_SendGoal_Response>
  : std::integral_constant<bool, has_bounded_size<builtin_interfaces::msg::Time>::value> {};

template<>
struct is_message<kompass_interfaces::action::MotionRecording_SendGoal_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<kompass_interfaces::action::MotionRecording_SendGoal>()
{
  return "kompass_interfaces::action::MotionRecording_SendGoal";
}

template<>
inline const char * name<kompass_interfaces::action::MotionRecording_SendGoal>()
{
  return "kompass_interfaces/action/MotionRecording_SendGoal";
}

template<>
struct has_fixed_size<kompass_interfaces::action::MotionRecording_SendGoal>
  : std::integral_constant<
    bool,
    has_fixed_size<kompass_interfaces::action::MotionRecording_SendGoal_Request>::value &&
    has_fixed_size<kompass_interfaces::action::MotionRecording_SendGoal_Response>::value
  >
{
};

template<>
struct has_bounded_size<kompass_interfaces::action::MotionRecording_SendGoal>
  : std::integral_constant<
    bool,
    has_bounded_size<kompass_interfaces::action::MotionRecording_SendGoal_Request>::value &&
    has_bounded_size<kompass_interfaces::action::MotionRecording_SendGoal_Response>::value
  >
{
};

template<>
struct is_service<kompass_interfaces::action::MotionRecording_SendGoal>
  : std::true_type
{
};

template<>
struct is_service_request<kompass_interfaces::action::MotionRecording_SendGoal_Request>
  : std::true_type
{
};

template<>
struct is_service_response<kompass_interfaces::action::MotionRecording_SendGoal_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__traits.hpp"

namespace kompass_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const MotionRecording_GetResult_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: goal_id
  {
    out << "goal_id: ";
    to_flow_style_yaml(msg.goal_id, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const MotionRecording_GetResult_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: goal_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal_id:\n";
    to_block_style_yaml(msg.goal_id, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const MotionRecording_GetResult_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace kompass_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use kompass_interfaces::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const kompass_interfaces::action::MotionRecording_GetResult_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  kompass_interfaces::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use kompass_interfaces::action::to_yaml() instead")]]
inline std::string to_yaml(const kompass_interfaces::action::MotionRecording_GetResult_Request & msg)
{
  return kompass_interfaces::action::to_yaml(msg);
}

template<>
inline const char * data_type<kompass_interfaces::action::MotionRecording_GetResult_Request>()
{
  return "kompass_interfaces::action::MotionRecording_GetResult_Request";
}

template<>
inline const char * name<kompass_interfaces::action::MotionRecording_GetResult_Request>()
{
  return "kompass_interfaces/action/MotionRecording_GetResult_Request";
}

template<>
struct has_fixed_size<kompass_interfaces::action::MotionRecording_GetResult_Request>
  : std::integral_constant<bool, has_fixed_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct has_bounded_size<kompass_interfaces::action::MotionRecording_GetResult_Request>
  : std::integral_constant<bool, has_bounded_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct is_message<kompass_interfaces::action::MotionRecording_GetResult_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'result'
// already included above
// #include "kompass_interfaces/action/detail/motion_recording__traits.hpp"

namespace kompass_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const MotionRecording_GetResult_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: status
  {
    out << "status: ";
    rosidl_generator_traits::value_to_yaml(msg.status, out);
    out << ", ";
  }

  // member: result
  {
    out << "result: ";
    to_flow_style_yaml(msg.result, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const MotionRecording_GetResult_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: status
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "status: ";
    rosidl_generator_traits::value_to_yaml(msg.status, out);
    out << "\n";
  }

  // member: result
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "result:\n";
    to_block_style_yaml(msg.result, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const MotionRecording_GetResult_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace kompass_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use kompass_interfaces::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const kompass_interfaces::action::MotionRecording_GetResult_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  kompass_interfaces::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use kompass_interfaces::action::to_yaml() instead")]]
inline std::string to_yaml(const kompass_interfaces::action::MotionRecording_GetResult_Response & msg)
{
  return kompass_interfaces::action::to_yaml(msg);
}

template<>
inline const char * data_type<kompass_interfaces::action::MotionRecording_GetResult_Response>()
{
  return "kompass_interfaces::action::MotionRecording_GetResult_Response";
}

template<>
inline const char * name<kompass_interfaces::action::MotionRecording_GetResult_Response>()
{
  return "kompass_interfaces/action/MotionRecording_GetResult_Response";
}

template<>
struct has_fixed_size<kompass_interfaces::action::MotionRecording_GetResult_Response>
  : std::integral_constant<bool, has_fixed_size<kompass_interfaces::action::MotionRecording_Result>::value> {};

template<>
struct has_bounded_size<kompass_interfaces::action::MotionRecording_GetResult_Response>
  : std::integral_constant<bool, has_bounded_size<kompass_interfaces::action::MotionRecording_Result>::value> {};

template<>
struct is_message<kompass_interfaces::action::MotionRecording_GetResult_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<kompass_interfaces::action::MotionRecording_GetResult>()
{
  return "kompass_interfaces::action::MotionRecording_GetResult";
}

template<>
inline const char * name<kompass_interfaces::action::MotionRecording_GetResult>()
{
  return "kompass_interfaces/action/MotionRecording_GetResult";
}

template<>
struct has_fixed_size<kompass_interfaces::action::MotionRecording_GetResult>
  : std::integral_constant<
    bool,
    has_fixed_size<kompass_interfaces::action::MotionRecording_GetResult_Request>::value &&
    has_fixed_size<kompass_interfaces::action::MotionRecording_GetResult_Response>::value
  >
{
};

template<>
struct has_bounded_size<kompass_interfaces::action::MotionRecording_GetResult>
  : std::integral_constant<
    bool,
    has_bounded_size<kompass_interfaces::action::MotionRecording_GetResult_Request>::value &&
    has_bounded_size<kompass_interfaces::action::MotionRecording_GetResult_Response>::value
  >
{
};

template<>
struct is_service<kompass_interfaces::action::MotionRecording_GetResult>
  : std::true_type
{
};

template<>
struct is_service_request<kompass_interfaces::action::MotionRecording_GetResult_Request>
  : std::true_type
{
};

template<>
struct is_service_response<kompass_interfaces::action::MotionRecording_GetResult_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__traits.hpp"
// Member 'feedback'
// already included above
// #include "kompass_interfaces/action/detail/motion_recording__traits.hpp"

namespace kompass_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const MotionRecording_FeedbackMessage & msg,
  std::ostream & out)
{
  out << "{";
  // member: goal_id
  {
    out << "goal_id: ";
    to_flow_style_yaml(msg.goal_id, out);
    out << ", ";
  }

  // member: feedback
  {
    out << "feedback: ";
    to_flow_style_yaml(msg.feedback, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const MotionRecording_FeedbackMessage & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: goal_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal_id:\n";
    to_block_style_yaml(msg.goal_id, out, indentation + 2);
  }

  // member: feedback
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "feedback:\n";
    to_block_style_yaml(msg.feedback, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const MotionRecording_FeedbackMessage & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace kompass_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use kompass_interfaces::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const kompass_interfaces::action::MotionRecording_FeedbackMessage & msg,
  std::ostream & out, size_t indentation = 0)
{
  kompass_interfaces::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use kompass_interfaces::action::to_yaml() instead")]]
inline std::string to_yaml(const kompass_interfaces::action::MotionRecording_FeedbackMessage & msg)
{
  return kompass_interfaces::action::to_yaml(msg);
}

template<>
inline const char * data_type<kompass_interfaces::action::MotionRecording_FeedbackMessage>()
{
  return "kompass_interfaces::action::MotionRecording_FeedbackMessage";
}

template<>
inline const char * name<kompass_interfaces::action::MotionRecording_FeedbackMessage>()
{
  return "kompass_interfaces/action/MotionRecording_FeedbackMessage";
}

template<>
struct has_fixed_size<kompass_interfaces::action::MotionRecording_FeedbackMessage>
  : std::integral_constant<bool, has_fixed_size<kompass_interfaces::action::MotionRecording_Feedback>::value && has_fixed_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct has_bounded_size<kompass_interfaces::action::MotionRecording_FeedbackMessage>
  : std::integral_constant<bool, has_bounded_size<kompass_interfaces::action::MotionRecording_Feedback>::value && has_bounded_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct is_message<kompass_interfaces::action::MotionRecording_FeedbackMessage>
  : std::true_type {};

}  // namespace rosidl_generator_traits


namespace rosidl_generator_traits
{

template<>
struct is_action<kompass_interfaces::action::MotionRecording>
  : std::true_type
{
};

template<>
struct is_action_goal<kompass_interfaces::action::MotionRecording_Goal>
  : std::true_type
{
};

template<>
struct is_action_result<kompass_interfaces::action::MotionRecording_Result>
  : std::true_type
{
};

template<>
struct is_action_feedback<kompass_interfaces::action::MotionRecording_Feedback>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits


#endif  // KOMPASS_INTERFACES__ACTION__DETAIL__MOTION_RECORDING__TRAITS_HPP_
