// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from kompass_interfaces:msg/Obstacles.idl
// generated code does not contain a copyright notice
#include "kompass_interfaces/msg/detail/obstacles__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `info`
#include "nav_msgs/msg/detail/map_meta_data__functions.h"
// Member `obstacle_type`
// Member `x_global`
// Member `y_global`
// Member `x_local`
// Member `y_local`
// Member `i_grid`
// Member `j_grid`
// Member `occupied_zone`
// Member `class_id`
// Member `object_id`
// Member `vx`
// Member `vy`
#include "rosidl_runtime_c/primitives_sequence_functions.h"

bool
kompass_interfaces__msg__Obstacles__init(kompass_interfaces__msg__Obstacles * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    kompass_interfaces__msg__Obstacles__fini(msg);
    return false;
  }
  // info
  if (!nav_msgs__msg__MapMetaData__init(&msg->info)) {
    kompass_interfaces__msg__Obstacles__fini(msg);
    return false;
  }
  // obstacle_type
  if (!rosidl_runtime_c__int32__Sequence__init(&msg->obstacle_type, 0)) {
    kompass_interfaces__msg__Obstacles__fini(msg);
    return false;
  }
  // x_global
  if (!rosidl_runtime_c__float__Sequence__init(&msg->x_global, 0)) {
    kompass_interfaces__msg__Obstacles__fini(msg);
    return false;
  }
  // y_global
  if (!rosidl_runtime_c__float__Sequence__init(&msg->y_global, 0)) {
    kompass_interfaces__msg__Obstacles__fini(msg);
    return false;
  }
  // x_local
  if (!rosidl_runtime_c__float__Sequence__init(&msg->x_local, 0)) {
    kompass_interfaces__msg__Obstacles__fini(msg);
    return false;
  }
  // y_local
  if (!rosidl_runtime_c__float__Sequence__init(&msg->y_local, 0)) {
    kompass_interfaces__msg__Obstacles__fini(msg);
    return false;
  }
  // i_grid
  if (!rosidl_runtime_c__int32__Sequence__init(&msg->i_grid, 0)) {
    kompass_interfaces__msg__Obstacles__fini(msg);
    return false;
  }
  // j_grid
  if (!rosidl_runtime_c__int32__Sequence__init(&msg->j_grid, 0)) {
    kompass_interfaces__msg__Obstacles__fini(msg);
    return false;
  }
  // occupied_zone
  if (!rosidl_runtime_c__float__Sequence__init(&msg->occupied_zone, 0)) {
    kompass_interfaces__msg__Obstacles__fini(msg);
    return false;
  }
  // class_id
  if (!rosidl_runtime_c__int32__Sequence__init(&msg->class_id, 0)) {
    kompass_interfaces__msg__Obstacles__fini(msg);
    return false;
  }
  // object_id
  if (!rosidl_runtime_c__int32__Sequence__init(&msg->object_id, 0)) {
    kompass_interfaces__msg__Obstacles__fini(msg);
    return false;
  }
  // vx
  if (!rosidl_runtime_c__float__Sequence__init(&msg->vx, 0)) {
    kompass_interfaces__msg__Obstacles__fini(msg);
    return false;
  }
  // vy
  if (!rosidl_runtime_c__float__Sequence__init(&msg->vy, 0)) {
    kompass_interfaces__msg__Obstacles__fini(msg);
    return false;
  }
  return true;
}

void
kompass_interfaces__msg__Obstacles__fini(kompass_interfaces__msg__Obstacles * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // info
  nav_msgs__msg__MapMetaData__fini(&msg->info);
  // obstacle_type
  rosidl_runtime_c__int32__Sequence__fini(&msg->obstacle_type);
  // x_global
  rosidl_runtime_c__float__Sequence__fini(&msg->x_global);
  // y_global
  rosidl_runtime_c__float__Sequence__fini(&msg->y_global);
  // x_local
  rosidl_runtime_c__float__Sequence__fini(&msg->x_local);
  // y_local
  rosidl_runtime_c__float__Sequence__fini(&msg->y_local);
  // i_grid
  rosidl_runtime_c__int32__Sequence__fini(&msg->i_grid);
  // j_grid
  rosidl_runtime_c__int32__Sequence__fini(&msg->j_grid);
  // occupied_zone
  rosidl_runtime_c__float__Sequence__fini(&msg->occupied_zone);
  // class_id
  rosidl_runtime_c__int32__Sequence__fini(&msg->class_id);
  // object_id
  rosidl_runtime_c__int32__Sequence__fini(&msg->object_id);
  // vx
  rosidl_runtime_c__float__Sequence__fini(&msg->vx);
  // vy
  rosidl_runtime_c__float__Sequence__fini(&msg->vy);
}

bool
kompass_interfaces__msg__Obstacles__are_equal(const kompass_interfaces__msg__Obstacles * lhs, const kompass_interfaces__msg__Obstacles * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // info
  if (!nav_msgs__msg__MapMetaData__are_equal(
      &(lhs->info), &(rhs->info)))
  {
    return false;
  }
  // obstacle_type
  if (!rosidl_runtime_c__int32__Sequence__are_equal(
      &(lhs->obstacle_type), &(rhs->obstacle_type)))
  {
    return false;
  }
  // x_global
  if (!rosidl_runtime_c__float__Sequence__are_equal(
      &(lhs->x_global), &(rhs->x_global)))
  {
    return false;
  }
  // y_global
  if (!rosidl_runtime_c__float__Sequence__are_equal(
      &(lhs->y_global), &(rhs->y_global)))
  {
    return false;
  }
  // x_local
  if (!rosidl_runtime_c__float__Sequence__are_equal(
      &(lhs->x_local), &(rhs->x_local)))
  {
    return false;
  }
  // y_local
  if (!rosidl_runtime_c__float__Sequence__are_equal(
      &(lhs->y_local), &(rhs->y_local)))
  {
    return false;
  }
  // i_grid
  if (!rosidl_runtime_c__int32__Sequence__are_equal(
      &(lhs->i_grid), &(rhs->i_grid)))
  {
    return false;
  }
  // j_grid
  if (!rosidl_runtime_c__int32__Sequence__are_equal(
      &(lhs->j_grid), &(rhs->j_grid)))
  {
    return false;
  }
  // occupied_zone
  if (!rosidl_runtime_c__float__Sequence__are_equal(
      &(lhs->occupied_zone), &(rhs->occupied_zone)))
  {
    return false;
  }
  // class_id
  if (!rosidl_runtime_c__int32__Sequence__are_equal(
      &(lhs->class_id), &(rhs->class_id)))
  {
    return false;
  }
  // object_id
  if (!rosidl_runtime_c__int32__Sequence__are_equal(
      &(lhs->object_id), &(rhs->object_id)))
  {
    return false;
  }
  // vx
  if (!rosidl_runtime_c__float__Sequence__are_equal(
      &(lhs->vx), &(rhs->vx)))
  {
    return false;
  }
  // vy
  if (!rosidl_runtime_c__float__Sequence__are_equal(
      &(lhs->vy), &(rhs->vy)))
  {
    return false;
  }
  return true;
}

bool
kompass_interfaces__msg__Obstacles__copy(
  const kompass_interfaces__msg__Obstacles * input,
  kompass_interfaces__msg__Obstacles * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // info
  if (!nav_msgs__msg__MapMetaData__copy(
      &(input->info), &(output->info)))
  {
    return false;
  }
  // obstacle_type
  if (!rosidl_runtime_c__int32__Sequence__copy(
      &(input->obstacle_type), &(output->obstacle_type)))
  {
    return false;
  }
  // x_global
  if (!rosidl_runtime_c__float__Sequence__copy(
      &(input->x_global), &(output->x_global)))
  {
    return false;
  }
  // y_global
  if (!rosidl_runtime_c__float__Sequence__copy(
      &(input->y_global), &(output->y_global)))
  {
    return false;
  }
  // x_local
  if (!rosidl_runtime_c__float__Sequence__copy(
      &(input->x_local), &(output->x_local)))
  {
    return false;
  }
  // y_local
  if (!rosidl_runtime_c__float__Sequence__copy(
      &(input->y_local), &(output->y_local)))
  {
    return false;
  }
  // i_grid
  if (!rosidl_runtime_c__int32__Sequence__copy(
      &(input->i_grid), &(output->i_grid)))
  {
    return false;
  }
  // j_grid
  if (!rosidl_runtime_c__int32__Sequence__copy(
      &(input->j_grid), &(output->j_grid)))
  {
    return false;
  }
  // occupied_zone
  if (!rosidl_runtime_c__float__Sequence__copy(
      &(input->occupied_zone), &(output->occupied_zone)))
  {
    return false;
  }
  // class_id
  if (!rosidl_runtime_c__int32__Sequence__copy(
      &(input->class_id), &(output->class_id)))
  {
    return false;
  }
  // object_id
  if (!rosidl_runtime_c__int32__Sequence__copy(
      &(input->object_id), &(output->object_id)))
  {
    return false;
  }
  // vx
  if (!rosidl_runtime_c__float__Sequence__copy(
      &(input->vx), &(output->vx)))
  {
    return false;
  }
  // vy
  if (!rosidl_runtime_c__float__Sequence__copy(
      &(input->vy), &(output->vy)))
  {
    return false;
  }
  return true;
}

kompass_interfaces__msg__Obstacles *
kompass_interfaces__msg__Obstacles__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  kompass_interfaces__msg__Obstacles * msg = (kompass_interfaces__msg__Obstacles *)allocator.allocate(sizeof(kompass_interfaces__msg__Obstacles), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(kompass_interfaces__msg__Obstacles));
  bool success = kompass_interfaces__msg__Obstacles__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
kompass_interfaces__msg__Obstacles__destroy(kompass_interfaces__msg__Obstacles * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    kompass_interfaces__msg__Obstacles__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
kompass_interfaces__msg__Obstacles__Sequence__init(kompass_interfaces__msg__Obstacles__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  kompass_interfaces__msg__Obstacles * data = NULL;

  if (size) {
    data = (kompass_interfaces__msg__Obstacles *)allocator.zero_allocate(size, sizeof(kompass_interfaces__msg__Obstacles), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = kompass_interfaces__msg__Obstacles__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        kompass_interfaces__msg__Obstacles__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
kompass_interfaces__msg__Obstacles__Sequence__fini(kompass_interfaces__msg__Obstacles__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      kompass_interfaces__msg__Obstacles__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

kompass_interfaces__msg__Obstacles__Sequence *
kompass_interfaces__msg__Obstacles__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  kompass_interfaces__msg__Obstacles__Sequence * array = (kompass_interfaces__msg__Obstacles__Sequence *)allocator.allocate(sizeof(kompass_interfaces__msg__Obstacles__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = kompass_interfaces__msg__Obstacles__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
kompass_interfaces__msg__Obstacles__Sequence__destroy(kompass_interfaces__msg__Obstacles__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    kompass_interfaces__msg__Obstacles__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
kompass_interfaces__msg__Obstacles__Sequence__are_equal(const kompass_interfaces__msg__Obstacles__Sequence * lhs, const kompass_interfaces__msg__Obstacles__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!kompass_interfaces__msg__Obstacles__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
kompass_interfaces__msg__Obstacles__Sequence__copy(
  const kompass_interfaces__msg__Obstacles__Sequence * input,
  kompass_interfaces__msg__Obstacles__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(kompass_interfaces__msg__Obstacles);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    kompass_interfaces__msg__Obstacles * data =
      (kompass_interfaces__msg__Obstacles *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!kompass_interfaces__msg__Obstacles__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          kompass_interfaces__msg__Obstacles__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!kompass_interfaces__msg__Obstacles__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
