// generated from rosidl_typesupport_introspection_cpp/resource/idl__type_support.cpp.em
// with input from kompass_interfaces:msg/PredictedOccupancies.idl
// generated code does not contain a copyright notice

#include "array"
#include "cstddef"
#include "string"
#include "vector"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_interface/macros.h"
#include "kompass_interfaces/msg/detail/predicted_occupancies__struct.hpp"
#include "rosidl_typesupport_introspection_cpp/field_types.hpp"
#include "rosidl_typesupport_introspection_cpp/identifier.hpp"
#include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
#include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace kompass_interfaces
{

namespace msg
{

namespace rosidl_typesupport_introspection_cpp
{

void PredictedOccupancies_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) kompass_interfaces::msg::PredictedOccupancies(_init);
}

void PredictedOccupancies_fini_function(void * message_memory)
{
  auto typed_message = static_cast<kompass_interfaces::msg::PredictedOccupancies *>(message_memory);
  typed_message->~PredictedOccupancies();
}

size_t size_function__PredictedOccupancies__obstacles(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<kompass_interfaces::msg::Obstacles> *>(untyped_member);
  return member->size();
}

const void * get_const_function__PredictedOccupancies__obstacles(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<kompass_interfaces::msg::Obstacles> *>(untyped_member);
  return &member[index];
}

void * get_function__PredictedOccupancies__obstacles(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<kompass_interfaces::msg::Obstacles> *>(untyped_member);
  return &member[index];
}

void fetch_function__PredictedOccupancies__obstacles(
  const void * untyped_member, size_t index, void * untyped_value)
{
  const auto & item = *reinterpret_cast<const kompass_interfaces::msg::Obstacles *>(
    get_const_function__PredictedOccupancies__obstacles(untyped_member, index));
  auto & value = *reinterpret_cast<kompass_interfaces::msg::Obstacles *>(untyped_value);
  value = item;
}

void assign_function__PredictedOccupancies__obstacles(
  void * untyped_member, size_t index, const void * untyped_value)
{
  auto & item = *reinterpret_cast<kompass_interfaces::msg::Obstacles *>(
    get_function__PredictedOccupancies__obstacles(untyped_member, index));
  const auto & value = *reinterpret_cast<const kompass_interfaces::msg::Obstacles *>(untyped_value);
  item = value;
}

void resize_function__PredictedOccupancies__obstacles(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<kompass_interfaces::msg::Obstacles> *>(untyped_member);
  member->resize(size);
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember PredictedOccupancies_message_member_array[5] = {
  {
    "header",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<std_msgs::msg::Header>(),  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(kompass_interfaces::msg::PredictedOccupancies, header),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "start_time",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_FLOAT,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(kompass_interfaces::msg::PredictedOccupancies, start_time),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "horizon",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_FLOAT,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(kompass_interfaces::msg::PredictedOccupancies, horizon),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "time_step",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_FLOAT,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(kompass_interfaces::msg::PredictedOccupancies, time_step),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "obstacles",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<kompass_interfaces::msg::Obstacles>(),  // members of sub message
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(kompass_interfaces::msg::PredictedOccupancies, obstacles),  // bytes offset in struct
    nullptr,  // default value
    size_function__PredictedOccupancies__obstacles,  // size() function pointer
    get_const_function__PredictedOccupancies__obstacles,  // get_const(index) function pointer
    get_function__PredictedOccupancies__obstacles,  // get(index) function pointer
    fetch_function__PredictedOccupancies__obstacles,  // fetch(index, &value) function pointer
    assign_function__PredictedOccupancies__obstacles,  // assign(index, value) function pointer
    resize_function__PredictedOccupancies__obstacles  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers PredictedOccupancies_message_members = {
  "kompass_interfaces::msg",  // message namespace
  "PredictedOccupancies",  // message name
  5,  // number of fields
  sizeof(kompass_interfaces::msg::PredictedOccupancies),
  PredictedOccupancies_message_member_array,  // message members
  PredictedOccupancies_init_function,  // function to initialize message memory (memory has to be allocated)
  PredictedOccupancies_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t PredictedOccupancies_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &PredictedOccupancies_message_members,
  get_message_typesupport_handle_function,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace msg

}  // namespace kompass_interfaces


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<kompass_interfaces::msg::PredictedOccupancies>()
{
  return &::kompass_interfaces::msg::rosidl_typesupport_introspection_cpp::PredictedOccupancies_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, kompass_interfaces, msg, PredictedOccupancies)() {
  return &::kompass_interfaces::msg::rosidl_typesupport_introspection_cpp::PredictedOccupancies_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif
