// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from kompass_interfaces:msg/TwistArray.idl
// generated code does not contain a copyright notice

#ifndef KOMPASS_INTERFACES__MSG__DETAIL__TWIST_ARRAY__TRAITS_HPP_
#define KOMPASS_INTERFACES__MSG__DETAIL__TWIST_ARRAY__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "kompass_interfaces/msg/detail/twist_array__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'linear_velocities'
// Member 'angular_velocities'
#include "kompass_interfaces/msg/detail/vector_array__traits.hpp"

namespace kompass_interfaces
{

namespace msg
{

inline void to_flow_style_yaml(
  const TwistArray & msg,
  std::ostream & out)
{
  out << "{";
  // member: linear_velocities
  {
    out << "linear_velocities: ";
    to_flow_style_yaml(msg.linear_velocities, out);
    out << ", ";
  }

  // member: angular_velocities
  {
    out << "angular_velocities: ";
    to_flow_style_yaml(msg.angular_velocities, out);
    out << ", ";
  }

  // member: time_step
  {
    out << "time_step: ";
    rosidl_generator_traits::value_to_yaml(msg.time_step, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const TwistArray & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: linear_velocities
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "linear_velocities:\n";
    to_block_style_yaml(msg.linear_velocities, out, indentation + 2);
  }

  // member: angular_velocities
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "angular_velocities:\n";
    to_block_style_yaml(msg.angular_velocities, out, indentation + 2);
  }

  // member: time_step
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "time_step: ";
    rosidl_generator_traits::value_to_yaml(msg.time_step, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const TwistArray & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace kompass_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use kompass_interfaces::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const kompass_interfaces::msg::TwistArray & msg,
  std::ostream & out, size_t indentation = 0)
{
  kompass_interfaces::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use kompass_interfaces::msg::to_yaml() instead")]]
inline std::string to_yaml(const kompass_interfaces::msg::TwistArray & msg)
{
  return kompass_interfaces::msg::to_yaml(msg);
}

template<>
inline const char * data_type<kompass_interfaces::msg::TwistArray>()
{
  return "kompass_interfaces::msg::TwistArray";
}

template<>
inline const char * name<kompass_interfaces::msg::TwistArray>()
{
  return "kompass_interfaces/msg/TwistArray";
}

template<>
struct has_fixed_size<kompass_interfaces::msg::TwistArray>
  : std::integral_constant<bool, has_fixed_size<kompass_interfaces::msg::VectorArray>::value> {};

template<>
struct has_bounded_size<kompass_interfaces::msg::TwistArray>
  : std::integral_constant<bool, has_bounded_size<kompass_interfaces::msg::VectorArray>::value> {};

template<>
struct is_message<kompass_interfaces::msg::TwistArray>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // KOMPASS_INTERFACES__MSG__DETAIL__TWIST_ARRAY__TRAITS_HPP_
