// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from kompass_interfaces:msg/VectorArray.idl
// generated code does not contain a copyright notice

#ifndef KOMPASS_INTERFACES__MSG__DETAIL__VECTOR_ARRAY__STRUCT_HPP_
#define KOMPASS_INTERFACES__MSG__DETAIL__VECTOR_ARRAY__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__kompass_interfaces__msg__VectorArray __attribute__((deprecated))
#else
# define DEPRECATED__kompass_interfaces__msg__VectorArray __declspec(deprecated)
#endif

namespace kompass_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct VectorArray_
{
  using Type = VectorArray_<ContainerAllocator>;

  explicit VectorArray_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_init;
  }

  explicit VectorArray_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_init;
    (void)_alloc;
  }

  // field types and members
  using _x_type =
    std::vector<double, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<double>>;
  _x_type x;
  using _y_type =
    std::vector<double, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<double>>;
  _y_type y;
  using _z_type =
    std::vector<double, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<double>>;
  _z_type z;

  // setters for named parameter idiom
  Type & set__x(
    const std::vector<double, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<double>> & _arg)
  {
    this->x = _arg;
    return *this;
  }
  Type & set__y(
    const std::vector<double, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<double>> & _arg)
  {
    this->y = _arg;
    return *this;
  }
  Type & set__z(
    const std::vector<double, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<double>> & _arg)
  {
    this->z = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    kompass_interfaces::msg::VectorArray_<ContainerAllocator> *;
  using ConstRawPtr =
    const kompass_interfaces::msg::VectorArray_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<kompass_interfaces::msg::VectorArray_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<kompass_interfaces::msg::VectorArray_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::msg::VectorArray_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::msg::VectorArray_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::msg::VectorArray_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::msg::VectorArray_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<kompass_interfaces::msg::VectorArray_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<kompass_interfaces::msg::VectorArray_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__kompass_interfaces__msg__VectorArray
    std::shared_ptr<kompass_interfaces::msg::VectorArray_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__kompass_interfaces__msg__VectorArray
    std::shared_ptr<kompass_interfaces::msg::VectorArray_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const VectorArray_ & other) const
  {
    if (this->x != other.x) {
      return false;
    }
    if (this->y != other.y) {
      return false;
    }
    if (this->z != other.z) {
      return false;
    }
    return true;
  }
  bool operator!=(const VectorArray_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct VectorArray_

// alias to use template instance with default allocator
using VectorArray =
  kompass_interfaces::msg::VectorArray_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace kompass_interfaces

#endif  // KOMPASS_INTERFACES__MSG__DETAIL__VECTOR_ARRAY__STRUCT_HPP_
