// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from kompass_interfaces:srv/PlanPath.idl
// generated code does not contain a copyright notice

#ifndef KOMPASS_INTERFACES__SRV__DETAIL__PLAN_PATH__STRUCT_H_
#define KOMPASS_INTERFACES__SRV__DETAIL__PLAN_PATH__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'start'
// Member 'goal'
#include "geometry_msgs/msg/detail/pose__struct.h"

/// Struct defined in srv/PlanPath in the package kompass_interfaces.
typedef struct kompass_interfaces__srv__PlanPath_Request
{
  geometry_msgs__msg__Pose start;
  geometry_msgs__msg__Pose goal;
  /// True = Plan from current robot position and discard start in request
  bool from_robot_pose;
} kompass_interfaces__srv__PlanPath_Request;

// Struct for a sequence of kompass_interfaces__srv__PlanPath_Request.
typedef struct kompass_interfaces__srv__PlanPath_Request__Sequence
{
  kompass_interfaces__srv__PlanPath_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} kompass_interfaces__srv__PlanPath_Request__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'plan'
#include "nav_msgs/msg/detail/path__struct.h"

/// Struct defined in srv/PlanPath in the package kompass_interfaces.
typedef struct kompass_interfaces__srv__PlanPath_Response
{
  bool success;
  nav_msgs__msg__Path plan;
} kompass_interfaces__srv__PlanPath_Response;

// Struct for a sequence of kompass_interfaces__srv__PlanPath_Response.
typedef struct kompass_interfaces__srv__PlanPath_Response__Sequence
{
  kompass_interfaces__srv__PlanPath_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} kompass_interfaces__srv__PlanPath_Response__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // KOMPASS_INTERFACES__SRV__DETAIL__PLAN_PATH__STRUCT_H_
