// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from kompass_interfaces:action/PlanPath.idl
// generated code does not contain a copyright notice

#ifndef KOMPASS_INTERFACES__ACTION__DETAIL__PLAN_PATH__TRAITS_HPP_
#define KOMPASS_INTERFACES__ACTION__DETAIL__PLAN_PATH__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "kompass_interfaces/action/detail/plan_path__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'goal'
#include "geometry_msgs/msg/detail/pose__traits.hpp"
// Member 'end_tolerance'
#include "kompass_interfaces/msg/detail/path_tracking_error__traits.hpp"

namespace kompass_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const PlanPath_Goal & msg,
  std::ostream & out)
{
  out << "{";
  // member: goal
  {
    out << "goal: ";
    to_flow_style_yaml(msg.goal, out);
    out << ", ";
  }

  // member: algorithm_name
  {
    out << "algorithm_name: ";
    rosidl_generator_traits::value_to_yaml(msg.algorithm_name, out);
    out << ", ";
  }

  // member: end_tolerance
  {
    out << "end_tolerance: ";
    to_flow_style_yaml(msg.end_tolerance, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const PlanPath_Goal & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: goal
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal:\n";
    to_block_style_yaml(msg.goal, out, indentation + 2);
  }

  // member: algorithm_name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "algorithm_name: ";
    rosidl_generator_traits::value_to_yaml(msg.algorithm_name, out);
    out << "\n";
  }

  // member: end_tolerance
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "end_tolerance:\n";
    to_block_style_yaml(msg.end_tolerance, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const PlanPath_Goal & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace kompass_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use kompass_interfaces::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const kompass_interfaces::action::PlanPath_Goal & msg,
  std::ostream & out, size_t indentation = 0)
{
  kompass_interfaces::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use kompass_interfaces::action::to_yaml() instead")]]
inline std::string to_yaml(const kompass_interfaces::action::PlanPath_Goal & msg)
{
  return kompass_interfaces::action::to_yaml(msg);
}

template<>
inline const char * data_type<kompass_interfaces::action::PlanPath_Goal>()
{
  return "kompass_interfaces::action::PlanPath_Goal";
}

template<>
inline const char * name<kompass_interfaces::action::PlanPath_Goal>()
{
  return "kompass_interfaces/action/PlanPath_Goal";
}

template<>
struct has_fixed_size<kompass_interfaces::action::PlanPath_Goal>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<kompass_interfaces::action::PlanPath_Goal>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<kompass_interfaces::action::PlanPath_Goal>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'end_displacement'
// already included above
// #include "kompass_interfaces/msg/detail/path_tracking_error__traits.hpp"

namespace kompass_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const PlanPath_Result & msg,
  std::ostream & out)
{
  out << "{";
  // member: end_displacement
  {
    out << "end_displacement: ";
    to_flow_style_yaml(msg.end_displacement, out);
    out << ", ";
  }

  // member: reached_end
  {
    out << "reached_end: ";
    rosidl_generator_traits::value_to_yaml(msg.reached_end, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const PlanPath_Result & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: end_displacement
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "end_displacement:\n";
    to_block_style_yaml(msg.end_displacement, out, indentation + 2);
  }

  // member: reached_end
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "reached_end: ";
    rosidl_generator_traits::value_to_yaml(msg.reached_end, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const PlanPath_Result & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace kompass_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use kompass_interfaces::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const kompass_interfaces::action::PlanPath_Result & msg,
  std::ostream & out, size_t indentation = 0)
{
  kompass_interfaces::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use kompass_interfaces::action::to_yaml() instead")]]
inline std::string to_yaml(const kompass_interfaces::action::PlanPath_Result & msg)
{
  return kompass_interfaces::action::to_yaml(msg);
}

template<>
inline const char * data_type<kompass_interfaces::action::PlanPath_Result>()
{
  return "kompass_interfaces::action::PlanPath_Result";
}

template<>
inline const char * name<kompass_interfaces::action::PlanPath_Result>()
{
  return "kompass_interfaces/action/PlanPath_Result";
}

template<>
struct has_fixed_size<kompass_interfaces::action::PlanPath_Result>
  : std::integral_constant<bool, has_fixed_size<kompass_interfaces::msg::PathTrackingError>::value> {};

template<>
struct has_bounded_size<kompass_interfaces::action::PlanPath_Result>
  : std::integral_constant<bool, has_bounded_size<kompass_interfaces::msg::PathTrackingError>::value> {};

template<>
struct is_message<kompass_interfaces::action::PlanPath_Result>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'plan'
#include "nav_msgs/msg/detail/path__traits.hpp"

namespace kompass_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const PlanPath_Feedback & msg,
  std::ostream & out)
{
  out << "{";
  // member: plan
  {
    out << "plan: ";
    to_flow_style_yaml(msg.plan, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const PlanPath_Feedback & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: plan
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "plan:\n";
    to_block_style_yaml(msg.plan, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const PlanPath_Feedback & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace kompass_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use kompass_interfaces::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const kompass_interfaces::action::PlanPath_Feedback & msg,
  std::ostream & out, size_t indentation = 0)
{
  kompass_interfaces::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use kompass_interfaces::action::to_yaml() instead")]]
inline std::string to_yaml(const kompass_interfaces::action::PlanPath_Feedback & msg)
{
  return kompass_interfaces::action::to_yaml(msg);
}

template<>
inline const char * data_type<kompass_interfaces::action::PlanPath_Feedback>()
{
  return "kompass_interfaces::action::PlanPath_Feedback";
}

template<>
inline const char * name<kompass_interfaces::action::PlanPath_Feedback>()
{
  return "kompass_interfaces/action/PlanPath_Feedback";
}

template<>
struct has_fixed_size<kompass_interfaces::action::PlanPath_Feedback>
  : std::integral_constant<bool, has_fixed_size<nav_msgs::msg::Path>::value> {};

template<>
struct has_bounded_size<kompass_interfaces::action::PlanPath_Feedback>
  : std::integral_constant<bool, has_bounded_size<nav_msgs::msg::Path>::value> {};

template<>
struct is_message<kompass_interfaces::action::PlanPath_Feedback>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'goal_id'
#include "unique_identifier_msgs/msg/detail/uuid__traits.hpp"
// Member 'goal'
#include "kompass_interfaces/action/detail/plan_path__traits.hpp"

namespace kompass_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const PlanPath_SendGoal_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: goal_id
  {
    out << "goal_id: ";
    to_flow_style_yaml(msg.goal_id, out);
    out << ", ";
  }

  // member: goal
  {
    out << "goal: ";
    to_flow_style_yaml(msg.goal, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const PlanPath_SendGoal_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: goal_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal_id:\n";
    to_block_style_yaml(msg.goal_id, out, indentation + 2);
  }

  // member: goal
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal:\n";
    to_block_style_yaml(msg.goal, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const PlanPath_SendGoal_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace kompass_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use kompass_interfaces::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const kompass_interfaces::action::PlanPath_SendGoal_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  kompass_interfaces::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use kompass_interfaces::action::to_yaml() instead")]]
inline std::string to_yaml(const kompass_interfaces::action::PlanPath_SendGoal_Request & msg)
{
  return kompass_interfaces::action::to_yaml(msg);
}

template<>
inline const char * data_type<kompass_interfaces::action::PlanPath_SendGoal_Request>()
{
  return "kompass_interfaces::action::PlanPath_SendGoal_Request";
}

template<>
inline const char * name<kompass_interfaces::action::PlanPath_SendGoal_Request>()
{
  return "kompass_interfaces/action/PlanPath_SendGoal_Request";
}

template<>
struct has_fixed_size<kompass_interfaces::action::PlanPath_SendGoal_Request>
  : std::integral_constant<bool, has_fixed_size<kompass_interfaces::action::PlanPath_Goal>::value && has_fixed_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct has_bounded_size<kompass_interfaces::action::PlanPath_SendGoal_Request>
  : std::integral_constant<bool, has_bounded_size<kompass_interfaces::action::PlanPath_Goal>::value && has_bounded_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct is_message<kompass_interfaces::action::PlanPath_SendGoal_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__traits.hpp"

namespace kompass_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const PlanPath_SendGoal_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: accepted
  {
    out << "accepted: ";
    rosidl_generator_traits::value_to_yaml(msg.accepted, out);
    out << ", ";
  }

  // member: stamp
  {
    out << "stamp: ";
    to_flow_style_yaml(msg.stamp, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const PlanPath_SendGoal_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: accepted
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "accepted: ";
    rosidl_generator_traits::value_to_yaml(msg.accepted, out);
    out << "\n";
  }

  // member: stamp
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "stamp:\n";
    to_block_style_yaml(msg.stamp, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const PlanPath_SendGoal_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace kompass_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use kompass_interfaces::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const kompass_interfaces::action::PlanPath_SendGoal_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  kompass_interfaces::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use kompass_interfaces::action::to_yaml() instead")]]
inline std::string to_yaml(const kompass_interfaces::action::PlanPath_SendGoal_Response & msg)
{
  return kompass_interfaces::action::to_yaml(msg);
}

template<>
inline const char * data_type<kompass_interfaces::action::PlanPath_SendGoal_Response>()
{
  return "kompass_interfaces::action::PlanPath_SendGoal_Response";
}

template<>
inline const char * name<kompass_interfaces::action::PlanPath_SendGoal_Response>()
{
  return "kompass_interfaces/action/PlanPath_SendGoal_Response";
}

template<>
struct has_fixed_size<kompass_interfaces::action::PlanPath_SendGoal_Response>
  : std::integral_constant<bool, has_fixed_size<builtin_interfaces::msg::Time>::value> {};

template<>
struct has_bounded_size<kompass_interfaces::action::PlanPath_SendGoal_Response>
  : std::integral_constant<bool, has_bounded_size<builtin_interfaces::msg::Time>::value> {};

template<>
struct is_message<kompass_interfaces::action::PlanPath_SendGoal_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<kompass_interfaces::action::PlanPath_SendGoal>()
{
  return "kompass_interfaces::action::PlanPath_SendGoal";
}

template<>
inline const char * name<kompass_interfaces::action::PlanPath_SendGoal>()
{
  return "kompass_interfaces/action/PlanPath_SendGoal";
}

template<>
struct has_fixed_size<kompass_interfaces::action::PlanPath_SendGoal>
  : std::integral_constant<
    bool,
    has_fixed_size<kompass_interfaces::action::PlanPath_SendGoal_Request>::value &&
    has_fixed_size<kompass_interfaces::action::PlanPath_SendGoal_Response>::value
  >
{
};

template<>
struct has_bounded_size<kompass_interfaces::action::PlanPath_SendGoal>
  : std::integral_constant<
    bool,
    has_bounded_size<kompass_interfaces::action::PlanPath_SendGoal_Request>::value &&
    has_bounded_size<kompass_interfaces::action::PlanPath_SendGoal_Response>::value
  >
{
};

template<>
struct is_service<kompass_interfaces::action::PlanPath_SendGoal>
  : std::true_type
{
};

template<>
struct is_service_request<kompass_interfaces::action::PlanPath_SendGoal_Request>
  : std::true_type
{
};

template<>
struct is_service_response<kompass_interfaces::action::PlanPath_SendGoal_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__traits.hpp"

namespace kompass_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const PlanPath_GetResult_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: goal_id
  {
    out << "goal_id: ";
    to_flow_style_yaml(msg.goal_id, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const PlanPath_GetResult_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: goal_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal_id:\n";
    to_block_style_yaml(msg.goal_id, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const PlanPath_GetResult_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace kompass_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use kompass_interfaces::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const kompass_interfaces::action::PlanPath_GetResult_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  kompass_interfaces::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use kompass_interfaces::action::to_yaml() instead")]]
inline std::string to_yaml(const kompass_interfaces::action::PlanPath_GetResult_Request & msg)
{
  return kompass_interfaces::action::to_yaml(msg);
}

template<>
inline const char * data_type<kompass_interfaces::action::PlanPath_GetResult_Request>()
{
  return "kompass_interfaces::action::PlanPath_GetResult_Request";
}

template<>
inline const char * name<kompass_interfaces::action::PlanPath_GetResult_Request>()
{
  return "kompass_interfaces/action/PlanPath_GetResult_Request";
}

template<>
struct has_fixed_size<kompass_interfaces::action::PlanPath_GetResult_Request>
  : std::integral_constant<bool, has_fixed_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct has_bounded_size<kompass_interfaces::action::PlanPath_GetResult_Request>
  : std::integral_constant<bool, has_bounded_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct is_message<kompass_interfaces::action::PlanPath_GetResult_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'result'
// already included above
// #include "kompass_interfaces/action/detail/plan_path__traits.hpp"

namespace kompass_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const PlanPath_GetResult_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: status
  {
    out << "status: ";
    rosidl_generator_traits::value_to_yaml(msg.status, out);
    out << ", ";
  }

  // member: result
  {
    out << "result: ";
    to_flow_style_yaml(msg.result, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const PlanPath_GetResult_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: status
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "status: ";
    rosidl_generator_traits::value_to_yaml(msg.status, out);
    out << "\n";
  }

  // member: result
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "result:\n";
    to_block_style_yaml(msg.result, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const PlanPath_GetResult_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace kompass_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use kompass_interfaces::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const kompass_interfaces::action::PlanPath_GetResult_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  kompass_interfaces::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use kompass_interfaces::action::to_yaml() instead")]]
inline std::string to_yaml(const kompass_interfaces::action::PlanPath_GetResult_Response & msg)
{
  return kompass_interfaces::action::to_yaml(msg);
}

template<>
inline const char * data_type<kompass_interfaces::action::PlanPath_GetResult_Response>()
{
  return "kompass_interfaces::action::PlanPath_GetResult_Response";
}

template<>
inline const char * name<kompass_interfaces::action::PlanPath_GetResult_Response>()
{
  return "kompass_interfaces/action/PlanPath_GetResult_Response";
}

template<>
struct has_fixed_size<kompass_interfaces::action::PlanPath_GetResult_Response>
  : std::integral_constant<bool, has_fixed_size<kompass_interfaces::action::PlanPath_Result>::value> {};

template<>
struct has_bounded_size<kompass_interfaces::action::PlanPath_GetResult_Response>
  : std::integral_constant<bool, has_bounded_size<kompass_interfaces::action::PlanPath_Result>::value> {};

template<>
struct is_message<kompass_interfaces::action::PlanPath_GetResult_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<kompass_interfaces::action::PlanPath_GetResult>()
{
  return "kompass_interfaces::action::PlanPath_GetResult";
}

template<>
inline const char * name<kompass_interfaces::action::PlanPath_GetResult>()
{
  return "kompass_interfaces/action/PlanPath_GetResult";
}

template<>
struct has_fixed_size<kompass_interfaces::action::PlanPath_GetResult>
  : std::integral_constant<
    bool,
    has_fixed_size<kompass_interfaces::action::PlanPath_GetResult_Request>::value &&
    has_fixed_size<kompass_interfaces::action::PlanPath_GetResult_Response>::value
  >
{
};

template<>
struct has_bounded_size<kompass_interfaces::action::PlanPath_GetResult>
  : std::integral_constant<
    bool,
    has_bounded_size<kompass_interfaces::action::PlanPath_GetResult_Request>::value &&
    has_bounded_size<kompass_interfaces::action::PlanPath_GetResult_Response>::value
  >
{
};

template<>
struct is_service<kompass_interfaces::action::PlanPath_GetResult>
  : std::true_type
{
};

template<>
struct is_service_request<kompass_interfaces::action::PlanPath_GetResult_Request>
  : std::true_type
{
};

template<>
struct is_service_response<kompass_interfaces::action::PlanPath_GetResult_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__traits.hpp"
// Member 'feedback'
// already included above
// #include "kompass_interfaces/action/detail/plan_path__traits.hpp"

namespace kompass_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const PlanPath_FeedbackMessage & msg,
  std::ostream & out)
{
  out << "{";
  // member: goal_id
  {
    out << "goal_id: ";
    to_flow_style_yaml(msg.goal_id, out);
    out << ", ";
  }

  // member: feedback
  {
    out << "feedback: ";
    to_flow_style_yaml(msg.feedback, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const PlanPath_FeedbackMessage & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: goal_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal_id:\n";
    to_block_style_yaml(msg.goal_id, out, indentation + 2);
  }

  // member: feedback
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "feedback:\n";
    to_block_style_yaml(msg.feedback, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const PlanPath_FeedbackMessage & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace kompass_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use kompass_interfaces::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const kompass_interfaces::action::PlanPath_FeedbackMessage & msg,
  std::ostream & out, size_t indentation = 0)
{
  kompass_interfaces::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use kompass_interfaces::action::to_yaml() instead")]]
inline std::string to_yaml(const kompass_interfaces::action::PlanPath_FeedbackMessage & msg)
{
  return kompass_interfaces::action::to_yaml(msg);
}

template<>
inline const char * data_type<kompass_interfaces::action::PlanPath_FeedbackMessage>()
{
  return "kompass_interfaces::action::PlanPath_FeedbackMessage";
}

template<>
inline const char * name<kompass_interfaces::action::PlanPath_FeedbackMessage>()
{
  return "kompass_interfaces/action/PlanPath_FeedbackMessage";
}

template<>
struct has_fixed_size<kompass_interfaces::action::PlanPath_FeedbackMessage>
  : std::integral_constant<bool, has_fixed_size<kompass_interfaces::action::PlanPath_Feedback>::value && has_fixed_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct has_bounded_size<kompass_interfaces::action::PlanPath_FeedbackMessage>
  : std::integral_constant<bool, has_bounded_size<kompass_interfaces::action::PlanPath_Feedback>::value && has_bounded_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct is_message<kompass_interfaces::action::PlanPath_FeedbackMessage>
  : std::true_type {};

}  // namespace rosidl_generator_traits


namespace rosidl_generator_traits
{

template<>
struct is_action<kompass_interfaces::action::PlanPath>
  : std::true_type
{
};

template<>
struct is_action_goal<kompass_interfaces::action::PlanPath_Goal>
  : std::true_type
{
};

template<>
struct is_action_result<kompass_interfaces::action::PlanPath_Result>
  : std::true_type
{
};

template<>
struct is_action_feedback<kompass_interfaces::action::PlanPath_Feedback>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits


#endif  // KOMPASS_INTERFACES__ACTION__DETAIL__PLAN_PATH__TRAITS_HPP_
