// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from kompass_interfaces:action/TrackVisionTarget.idl
// generated code does not contain a copyright notice

#ifndef KOMPASS_INTERFACES__ACTION__DETAIL__TRACK_VISION_TARGET__BUILDER_HPP_
#define KOMPASS_INTERFACES__ACTION__DETAIL__TRACK_VISION_TARGET__BUILDER_HPP_

#include <algorithm>
#include <utility>

#include "kompass_interfaces/action/detail/track_vision_target__struct.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


namespace kompass_interfaces
{

namespace action
{

namespace builder
{

class Init_TrackVisionTarget_Goal_search_timeout
{
public:
  explicit Init_TrackVisionTarget_Goal_search_timeout(::kompass_interfaces::action::TrackVisionTarget_Goal & msg)
  : msg_(msg)
  {}
  ::kompass_interfaces::action::TrackVisionTarget_Goal search_timeout(::kompass_interfaces::action::TrackVisionTarget_Goal::_search_timeout_type arg)
  {
    msg_.search_timeout = std::move(arg);
    return std::move(msg_);
  }

private:
  ::kompass_interfaces::action::TrackVisionTarget_Goal msg_;
};

class Init_TrackVisionTarget_Goal_search_radius
{
public:
  explicit Init_TrackVisionTarget_Goal_search_radius(::kompass_interfaces::action::TrackVisionTarget_Goal & msg)
  : msg_(msg)
  {}
  Init_TrackVisionTarget_Goal_search_timeout search_radius(::kompass_interfaces::action::TrackVisionTarget_Goal::_search_radius_type arg)
  {
    msg_.search_radius = std::move(arg);
    return Init_TrackVisionTarget_Goal_search_timeout(msg_);
  }

private:
  ::kompass_interfaces::action::TrackVisionTarget_Goal msg_;
};

class Init_TrackVisionTarget_Goal_label
{
public:
  Init_TrackVisionTarget_Goal_label()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_TrackVisionTarget_Goal_search_radius label(::kompass_interfaces::action::TrackVisionTarget_Goal::_label_type arg)
  {
    msg_.label = std::move(arg);
    return Init_TrackVisionTarget_Goal_search_radius(msg_);
  }

private:
  ::kompass_interfaces::action::TrackVisionTarget_Goal msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::kompass_interfaces::action::TrackVisionTarget_Goal>()
{
  return kompass_interfaces::action::builder::Init_TrackVisionTarget_Goal_label();
}

}  // namespace kompass_interfaces


namespace kompass_interfaces
{

namespace action
{

namespace builder
{

class Init_TrackVisionTarget_Result_tracked_duration
{
public:
  explicit Init_TrackVisionTarget_Result_tracked_duration(::kompass_interfaces::action::TrackVisionTarget_Result & msg)
  : msg_(msg)
  {}
  ::kompass_interfaces::action::TrackVisionTarget_Result tracked_duration(::kompass_interfaces::action::TrackVisionTarget_Result::_tracked_duration_type arg)
  {
    msg_.tracked_duration = std::move(arg);
    return std::move(msg_);
  }

private:
  ::kompass_interfaces::action::TrackVisionTarget_Result msg_;
};

class Init_TrackVisionTarget_Result_success
{
public:
  Init_TrackVisionTarget_Result_success()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_TrackVisionTarget_Result_tracked_duration success(::kompass_interfaces::action::TrackVisionTarget_Result::_success_type arg)
  {
    msg_.success = std::move(arg);
    return Init_TrackVisionTarget_Result_tracked_duration(msg_);
  }

private:
  ::kompass_interfaces::action::TrackVisionTarget_Result msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::kompass_interfaces::action::TrackVisionTarget_Result>()
{
  return kompass_interfaces::action::builder::Init_TrackVisionTarget_Result_success();
}

}  // namespace kompass_interfaces


namespace kompass_interfaces
{

namespace action
{

namespace builder
{

class Init_TrackVisionTarget_Feedback_orientation
{
public:
  explicit Init_TrackVisionTarget_Feedback_orientation(::kompass_interfaces::action::TrackVisionTarget_Feedback & msg)
  : msg_(msg)
  {}
  ::kompass_interfaces::action::TrackVisionTarget_Feedback orientation(::kompass_interfaces::action::TrackVisionTarget_Feedback::_orientation_type arg)
  {
    msg_.orientation = std::move(arg);
    return std::move(msg_);
  }

private:
  ::kompass_interfaces::action::TrackVisionTarget_Feedback msg_;
};

class Init_TrackVisionTarget_Feedback_distance
{
public:
  explicit Init_TrackVisionTarget_Feedback_distance(::kompass_interfaces::action::TrackVisionTarget_Feedback & msg)
  : msg_(msg)
  {}
  Init_TrackVisionTarget_Feedback_orientation distance(::kompass_interfaces::action::TrackVisionTarget_Feedback::_distance_type arg)
  {
    msg_.distance = std::move(arg);
    return Init_TrackVisionTarget_Feedback_orientation(msg_);
  }

private:
  ::kompass_interfaces::action::TrackVisionTarget_Feedback msg_;
};

class Init_TrackVisionTarget_Feedback_size_xy
{
public:
  explicit Init_TrackVisionTarget_Feedback_size_xy(::kompass_interfaces::action::TrackVisionTarget_Feedback & msg)
  : msg_(msg)
  {}
  Init_TrackVisionTarget_Feedback_distance size_xy(::kompass_interfaces::action::TrackVisionTarget_Feedback::_size_xy_type arg)
  {
    msg_.size_xy = std::move(arg);
    return Init_TrackVisionTarget_Feedback_distance(msg_);
  }

private:
  ::kompass_interfaces::action::TrackVisionTarget_Feedback msg_;
};

class Init_TrackVisionTarget_Feedback_center_xy
{
public:
  explicit Init_TrackVisionTarget_Feedback_center_xy(::kompass_interfaces::action::TrackVisionTarget_Feedback & msg)
  : msg_(msg)
  {}
  Init_TrackVisionTarget_Feedback_size_xy center_xy(::kompass_interfaces::action::TrackVisionTarget_Feedback::_center_xy_type arg)
  {
    msg_.center_xy = std::move(arg);
    return Init_TrackVisionTarget_Feedback_size_xy(msg_);
  }

private:
  ::kompass_interfaces::action::TrackVisionTarget_Feedback msg_;
};

class Init_TrackVisionTarget_Feedback_score
{
public:
  Init_TrackVisionTarget_Feedback_score()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_TrackVisionTarget_Feedback_center_xy score(::kompass_interfaces::action::TrackVisionTarget_Feedback::_score_type arg)
  {
    msg_.score = std::move(arg);
    return Init_TrackVisionTarget_Feedback_center_xy(msg_);
  }

private:
  ::kompass_interfaces::action::TrackVisionTarget_Feedback msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::kompass_interfaces::action::TrackVisionTarget_Feedback>()
{
  return kompass_interfaces::action::builder::Init_TrackVisionTarget_Feedback_score();
}

}  // namespace kompass_interfaces


namespace kompass_interfaces
{

namespace action
{

namespace builder
{

class Init_TrackVisionTarget_SendGoal_Request_goal
{
public:
  explicit Init_TrackVisionTarget_SendGoal_Request_goal(::kompass_interfaces::action::TrackVisionTarget_SendGoal_Request & msg)
  : msg_(msg)
  {}
  ::kompass_interfaces::action::TrackVisionTarget_SendGoal_Request goal(::kompass_interfaces::action::TrackVisionTarget_SendGoal_Request::_goal_type arg)
  {
    msg_.goal = std::move(arg);
    return std::move(msg_);
  }

private:
  ::kompass_interfaces::action::TrackVisionTarget_SendGoal_Request msg_;
};

class Init_TrackVisionTarget_SendGoal_Request_goal_id
{
public:
  Init_TrackVisionTarget_SendGoal_Request_goal_id()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_TrackVisionTarget_SendGoal_Request_goal goal_id(::kompass_interfaces::action::TrackVisionTarget_SendGoal_Request::_goal_id_type arg)
  {
    msg_.goal_id = std::move(arg);
    return Init_TrackVisionTarget_SendGoal_Request_goal(msg_);
  }

private:
  ::kompass_interfaces::action::TrackVisionTarget_SendGoal_Request msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::kompass_interfaces::action::TrackVisionTarget_SendGoal_Request>()
{
  return kompass_interfaces::action::builder::Init_TrackVisionTarget_SendGoal_Request_goal_id();
}

}  // namespace kompass_interfaces


namespace kompass_interfaces
{

namespace action
{

namespace builder
{

class Init_TrackVisionTarget_SendGoal_Response_stamp
{
public:
  explicit Init_TrackVisionTarget_SendGoal_Response_stamp(::kompass_interfaces::action::TrackVisionTarget_SendGoal_Response & msg)
  : msg_(msg)
  {}
  ::kompass_interfaces::action::TrackVisionTarget_SendGoal_Response stamp(::kompass_interfaces::action::TrackVisionTarget_SendGoal_Response::_stamp_type arg)
  {
    msg_.stamp = std::move(arg);
    return std::move(msg_);
  }

private:
  ::kompass_interfaces::action::TrackVisionTarget_SendGoal_Response msg_;
};

class Init_TrackVisionTarget_SendGoal_Response_accepted
{
public:
  Init_TrackVisionTarget_SendGoal_Response_accepted()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_TrackVisionTarget_SendGoal_Response_stamp accepted(::kompass_interfaces::action::TrackVisionTarget_SendGoal_Response::_accepted_type arg)
  {
    msg_.accepted = std::move(arg);
    return Init_TrackVisionTarget_SendGoal_Response_stamp(msg_);
  }

private:
  ::kompass_interfaces::action::TrackVisionTarget_SendGoal_Response msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::kompass_interfaces::action::TrackVisionTarget_SendGoal_Response>()
{
  return kompass_interfaces::action::builder::Init_TrackVisionTarget_SendGoal_Response_accepted();
}

}  // namespace kompass_interfaces


namespace kompass_interfaces
{

namespace action
{

namespace builder
{

class Init_TrackVisionTarget_GetResult_Request_goal_id
{
public:
  Init_TrackVisionTarget_GetResult_Request_goal_id()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  ::kompass_interfaces::action::TrackVisionTarget_GetResult_Request goal_id(::kompass_interfaces::action::TrackVisionTarget_GetResult_Request::_goal_id_type arg)
  {
    msg_.goal_id = std::move(arg);
    return std::move(msg_);
  }

private:
  ::kompass_interfaces::action::TrackVisionTarget_GetResult_Request msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::kompass_interfaces::action::TrackVisionTarget_GetResult_Request>()
{
  return kompass_interfaces::action::builder::Init_TrackVisionTarget_GetResult_Request_goal_id();
}

}  // namespace kompass_interfaces


namespace kompass_interfaces
{

namespace action
{

namespace builder
{

class Init_TrackVisionTarget_GetResult_Response_result
{
public:
  explicit Init_TrackVisionTarget_GetResult_Response_result(::kompass_interfaces::action::TrackVisionTarget_GetResult_Response & msg)
  : msg_(msg)
  {}
  ::kompass_interfaces::action::TrackVisionTarget_GetResult_Response result(::kompass_interfaces::action::TrackVisionTarget_GetResult_Response::_result_type arg)
  {
    msg_.result = std::move(arg);
    return std::move(msg_);
  }

private:
  ::kompass_interfaces::action::TrackVisionTarget_GetResult_Response msg_;
};

class Init_TrackVisionTarget_GetResult_Response_status
{
public:
  Init_TrackVisionTarget_GetResult_Response_status()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_TrackVisionTarget_GetResult_Response_result status(::kompass_interfaces::action::TrackVisionTarget_GetResult_Response::_status_type arg)
  {
    msg_.status = std::move(arg);
    return Init_TrackVisionTarget_GetResult_Response_result(msg_);
  }

private:
  ::kompass_interfaces::action::TrackVisionTarget_GetResult_Response msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::kompass_interfaces::action::TrackVisionTarget_GetResult_Response>()
{
  return kompass_interfaces::action::builder::Init_TrackVisionTarget_GetResult_Response_status();
}

}  // namespace kompass_interfaces


namespace kompass_interfaces
{

namespace action
{

namespace builder
{

class Init_TrackVisionTarget_FeedbackMessage_feedback
{
public:
  explicit Init_TrackVisionTarget_FeedbackMessage_feedback(::kompass_interfaces::action::TrackVisionTarget_FeedbackMessage & msg)
  : msg_(msg)
  {}
  ::kompass_interfaces::action::TrackVisionTarget_FeedbackMessage feedback(::kompass_interfaces::action::TrackVisionTarget_FeedbackMessage::_feedback_type arg)
  {
    msg_.feedback = std::move(arg);
    return std::move(msg_);
  }

private:
  ::kompass_interfaces::action::TrackVisionTarget_FeedbackMessage msg_;
};

class Init_TrackVisionTarget_FeedbackMessage_goal_id
{
public:
  Init_TrackVisionTarget_FeedbackMessage_goal_id()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_TrackVisionTarget_FeedbackMessage_feedback goal_id(::kompass_interfaces::action::TrackVisionTarget_FeedbackMessage::_goal_id_type arg)
  {
    msg_.goal_id = std::move(arg);
    return Init_TrackVisionTarget_FeedbackMessage_feedback(msg_);
  }

private:
  ::kompass_interfaces::action::TrackVisionTarget_FeedbackMessage msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::kompass_interfaces::action::TrackVisionTarget_FeedbackMessage>()
{
  return kompass_interfaces::action::builder::Init_TrackVisionTarget_FeedbackMessage_goal_id();
}

}  // namespace kompass_interfaces

#endif  // KOMPASS_INTERFACES__ACTION__DETAIL__TRACK_VISION_TARGET__BUILDER_HPP_
