// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from kompass_interfaces:action/TrackVisionTarget.idl
// generated code does not contain a copyright notice

#ifndef KOMPASS_INTERFACES__ACTION__DETAIL__TRACK_VISION_TARGET__STRUCT_HPP_
#define KOMPASS_INTERFACES__ACTION__DETAIL__TRACK_VISION_TARGET__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__kompass_interfaces__action__TrackVisionTarget_Goal __attribute__((deprecated))
#else
# define DEPRECATED__kompass_interfaces__action__TrackVisionTarget_Goal __declspec(deprecated)
#endif

namespace kompass_interfaces
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct TrackVisionTarget_Goal_
{
  using Type = TrackVisionTarget_Goal_<ContainerAllocator>;

  explicit TrackVisionTarget_Goal_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->label = "";
      this->search_radius = 0.0;
      this->search_timeout = 0.0;
    }
  }

  explicit TrackVisionTarget_Goal_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : label(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->label = "";
      this->search_radius = 0.0;
      this->search_timeout = 0.0;
    }
  }

  // field types and members
  using _label_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _label_type label;
  using _search_radius_type =
    double;
  _search_radius_type search_radius;
  using _search_timeout_type =
    double;
  _search_timeout_type search_timeout;

  // setters for named parameter idiom
  Type & set__label(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->label = _arg;
    return *this;
  }
  Type & set__search_radius(
    const double & _arg)
  {
    this->search_radius = _arg;
    return *this;
  }
  Type & set__search_timeout(
    const double & _arg)
  {
    this->search_timeout = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    kompass_interfaces::action::TrackVisionTarget_Goal_<ContainerAllocator> *;
  using ConstRawPtr =
    const kompass_interfaces::action::TrackVisionTarget_Goal_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<kompass_interfaces::action::TrackVisionTarget_Goal_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<kompass_interfaces::action::TrackVisionTarget_Goal_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::TrackVisionTarget_Goal_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::TrackVisionTarget_Goal_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::TrackVisionTarget_Goal_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::TrackVisionTarget_Goal_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<kompass_interfaces::action::TrackVisionTarget_Goal_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<kompass_interfaces::action::TrackVisionTarget_Goal_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__kompass_interfaces__action__TrackVisionTarget_Goal
    std::shared_ptr<kompass_interfaces::action::TrackVisionTarget_Goal_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__kompass_interfaces__action__TrackVisionTarget_Goal
    std::shared_ptr<kompass_interfaces::action::TrackVisionTarget_Goal_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const TrackVisionTarget_Goal_ & other) const
  {
    if (this->label != other.label) {
      return false;
    }
    if (this->search_radius != other.search_radius) {
      return false;
    }
    if (this->search_timeout != other.search_timeout) {
      return false;
    }
    return true;
  }
  bool operator!=(const TrackVisionTarget_Goal_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct TrackVisionTarget_Goal_

// alias to use template instance with default allocator
using TrackVisionTarget_Goal =
  kompass_interfaces::action::TrackVisionTarget_Goal_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace kompass_interfaces


#ifndef _WIN32
# define DEPRECATED__kompass_interfaces__action__TrackVisionTarget_Result __attribute__((deprecated))
#else
# define DEPRECATED__kompass_interfaces__action__TrackVisionTarget_Result __declspec(deprecated)
#endif

namespace kompass_interfaces
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct TrackVisionTarget_Result_
{
  using Type = TrackVisionTarget_Result_<ContainerAllocator>;

  explicit TrackVisionTarget_Result_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
      this->tracked_duration = 0.0;
    }
  }

  explicit TrackVisionTarget_Result_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
      this->tracked_duration = 0.0;
    }
  }

  // field types and members
  using _success_type =
    bool;
  _success_type success;
  using _tracked_duration_type =
    double;
  _tracked_duration_type tracked_duration;

  // setters for named parameter idiom
  Type & set__success(
    const bool & _arg)
  {
    this->success = _arg;
    return *this;
  }
  Type & set__tracked_duration(
    const double & _arg)
  {
    this->tracked_duration = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    kompass_interfaces::action::TrackVisionTarget_Result_<ContainerAllocator> *;
  using ConstRawPtr =
    const kompass_interfaces::action::TrackVisionTarget_Result_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<kompass_interfaces::action::TrackVisionTarget_Result_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<kompass_interfaces::action::TrackVisionTarget_Result_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::TrackVisionTarget_Result_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::TrackVisionTarget_Result_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::TrackVisionTarget_Result_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::TrackVisionTarget_Result_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<kompass_interfaces::action::TrackVisionTarget_Result_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<kompass_interfaces::action::TrackVisionTarget_Result_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__kompass_interfaces__action__TrackVisionTarget_Result
    std::shared_ptr<kompass_interfaces::action::TrackVisionTarget_Result_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__kompass_interfaces__action__TrackVisionTarget_Result
    std::shared_ptr<kompass_interfaces::action::TrackVisionTarget_Result_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const TrackVisionTarget_Result_ & other) const
  {
    if (this->success != other.success) {
      return false;
    }
    if (this->tracked_duration != other.tracked_duration) {
      return false;
    }
    return true;
  }
  bool operator!=(const TrackVisionTarget_Result_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct TrackVisionTarget_Result_

// alias to use template instance with default allocator
using TrackVisionTarget_Result =
  kompass_interfaces::action::TrackVisionTarget_Result_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace kompass_interfaces


#ifndef _WIN32
# define DEPRECATED__kompass_interfaces__action__TrackVisionTarget_Feedback __attribute__((deprecated))
#else
# define DEPRECATED__kompass_interfaces__action__TrackVisionTarget_Feedback __declspec(deprecated)
#endif

namespace kompass_interfaces
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct TrackVisionTarget_Feedback_
{
  using Type = TrackVisionTarget_Feedback_<ContainerAllocator>;

  explicit TrackVisionTarget_Feedback_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->score = 0.0;
      this->distance = 0.0;
      this->orientation = 0.0;
    }
  }

  explicit TrackVisionTarget_Feedback_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->score = 0.0;
      this->distance = 0.0;
      this->orientation = 0.0;
    }
  }

  // field types and members
  using _score_type =
    double;
  _score_type score;
  using _center_xy_type =
    std::vector<double, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<double>>;
  _center_xy_type center_xy;
  using _size_xy_type =
    std::vector<double, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<double>>;
  _size_xy_type size_xy;
  using _distance_type =
    double;
  _distance_type distance;
  using _orientation_type =
    double;
  _orientation_type orientation;

  // setters for named parameter idiom
  Type & set__score(
    const double & _arg)
  {
    this->score = _arg;
    return *this;
  }
  Type & set__center_xy(
    const std::vector<double, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<double>> & _arg)
  {
    this->center_xy = _arg;
    return *this;
  }
  Type & set__size_xy(
    const std::vector<double, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<double>> & _arg)
  {
    this->size_xy = _arg;
    return *this;
  }
  Type & set__distance(
    const double & _arg)
  {
    this->distance = _arg;
    return *this;
  }
  Type & set__orientation(
    const double & _arg)
  {
    this->orientation = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    kompass_interfaces::action::TrackVisionTarget_Feedback_<ContainerAllocator> *;
  using ConstRawPtr =
    const kompass_interfaces::action::TrackVisionTarget_Feedback_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<kompass_interfaces::action::TrackVisionTarget_Feedback_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<kompass_interfaces::action::TrackVisionTarget_Feedback_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::TrackVisionTarget_Feedback_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::TrackVisionTarget_Feedback_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::TrackVisionTarget_Feedback_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::TrackVisionTarget_Feedback_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<kompass_interfaces::action::TrackVisionTarget_Feedback_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<kompass_interfaces::action::TrackVisionTarget_Feedback_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__kompass_interfaces__action__TrackVisionTarget_Feedback
    std::shared_ptr<kompass_interfaces::action::TrackVisionTarget_Feedback_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__kompass_interfaces__action__TrackVisionTarget_Feedback
    std::shared_ptr<kompass_interfaces::action::TrackVisionTarget_Feedback_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const TrackVisionTarget_Feedback_ & other) const
  {
    if (this->score != other.score) {
      return false;
    }
    if (this->center_xy != other.center_xy) {
      return false;
    }
    if (this->size_xy != other.size_xy) {
      return false;
    }
    if (this->distance != other.distance) {
      return false;
    }
    if (this->orientation != other.orientation) {
      return false;
    }
    return true;
  }
  bool operator!=(const TrackVisionTarget_Feedback_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct TrackVisionTarget_Feedback_

// alias to use template instance with default allocator
using TrackVisionTarget_Feedback =
  kompass_interfaces::action::TrackVisionTarget_Feedback_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace kompass_interfaces


// Include directives for member types
// Member 'goal_id'
#include "unique_identifier_msgs/msg/detail/uuid__struct.hpp"
// Member 'goal'
#include "kompass_interfaces/action/detail/track_vision_target__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__kompass_interfaces__action__TrackVisionTarget_SendGoal_Request __attribute__((deprecated))
#else
# define DEPRECATED__kompass_interfaces__action__TrackVisionTarget_SendGoal_Request __declspec(deprecated)
#endif

namespace kompass_interfaces
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct TrackVisionTarget_SendGoal_Request_
{
  using Type = TrackVisionTarget_SendGoal_Request_<ContainerAllocator>;

  explicit TrackVisionTarget_SendGoal_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_init),
    goal(_init)
  {
    (void)_init;
  }

  explicit TrackVisionTarget_SendGoal_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_alloc, _init),
    goal(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _goal_id_type =
    unique_identifier_msgs::msg::UUID_<ContainerAllocator>;
  _goal_id_type goal_id;
  using _goal_type =
    kompass_interfaces::action::TrackVisionTarget_Goal_<ContainerAllocator>;
  _goal_type goal;

  // setters for named parameter idiom
  Type & set__goal_id(
    const unique_identifier_msgs::msg::UUID_<ContainerAllocator> & _arg)
  {
    this->goal_id = _arg;
    return *this;
  }
  Type & set__goal(
    const kompass_interfaces::action::TrackVisionTarget_Goal_<ContainerAllocator> & _arg)
  {
    this->goal = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    kompass_interfaces::action::TrackVisionTarget_SendGoal_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const kompass_interfaces::action::TrackVisionTarget_SendGoal_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<kompass_interfaces::action::TrackVisionTarget_SendGoal_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<kompass_interfaces::action::TrackVisionTarget_SendGoal_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::TrackVisionTarget_SendGoal_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::TrackVisionTarget_SendGoal_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::TrackVisionTarget_SendGoal_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::TrackVisionTarget_SendGoal_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<kompass_interfaces::action::TrackVisionTarget_SendGoal_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<kompass_interfaces::action::TrackVisionTarget_SendGoal_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__kompass_interfaces__action__TrackVisionTarget_SendGoal_Request
    std::shared_ptr<kompass_interfaces::action::TrackVisionTarget_SendGoal_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__kompass_interfaces__action__TrackVisionTarget_SendGoal_Request
    std::shared_ptr<kompass_interfaces::action::TrackVisionTarget_SendGoal_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const TrackVisionTarget_SendGoal_Request_ & other) const
  {
    if (this->goal_id != other.goal_id) {
      return false;
    }
    if (this->goal != other.goal) {
      return false;
    }
    return true;
  }
  bool operator!=(const TrackVisionTarget_SendGoal_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct TrackVisionTarget_SendGoal_Request_

// alias to use template instance with default allocator
using TrackVisionTarget_SendGoal_Request =
  kompass_interfaces::action::TrackVisionTarget_SendGoal_Request_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace kompass_interfaces


// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__kompass_interfaces__action__TrackVisionTarget_SendGoal_Response __attribute__((deprecated))
#else
# define DEPRECATED__kompass_interfaces__action__TrackVisionTarget_SendGoal_Response __declspec(deprecated)
#endif

namespace kompass_interfaces
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct TrackVisionTarget_SendGoal_Response_
{
  using Type = TrackVisionTarget_SendGoal_Response_<ContainerAllocator>;

  explicit TrackVisionTarget_SendGoal_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : stamp(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->accepted = false;
    }
  }

  explicit TrackVisionTarget_SendGoal_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : stamp(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->accepted = false;
    }
  }

  // field types and members
  using _accepted_type =
    bool;
  _accepted_type accepted;
  using _stamp_type =
    builtin_interfaces::msg::Time_<ContainerAllocator>;
  _stamp_type stamp;

  // setters for named parameter idiom
  Type & set__accepted(
    const bool & _arg)
  {
    this->accepted = _arg;
    return *this;
  }
  Type & set__stamp(
    const builtin_interfaces::msg::Time_<ContainerAllocator> & _arg)
  {
    this->stamp = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    kompass_interfaces::action::TrackVisionTarget_SendGoal_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const kompass_interfaces::action::TrackVisionTarget_SendGoal_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<kompass_interfaces::action::TrackVisionTarget_SendGoal_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<kompass_interfaces::action::TrackVisionTarget_SendGoal_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::TrackVisionTarget_SendGoal_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::TrackVisionTarget_SendGoal_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::TrackVisionTarget_SendGoal_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::TrackVisionTarget_SendGoal_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<kompass_interfaces::action::TrackVisionTarget_SendGoal_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<kompass_interfaces::action::TrackVisionTarget_SendGoal_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__kompass_interfaces__action__TrackVisionTarget_SendGoal_Response
    std::shared_ptr<kompass_interfaces::action::TrackVisionTarget_SendGoal_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__kompass_interfaces__action__TrackVisionTarget_SendGoal_Response
    std::shared_ptr<kompass_interfaces::action::TrackVisionTarget_SendGoal_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const TrackVisionTarget_SendGoal_Response_ & other) const
  {
    if (this->accepted != other.accepted) {
      return false;
    }
    if (this->stamp != other.stamp) {
      return false;
    }
    return true;
  }
  bool operator!=(const TrackVisionTarget_SendGoal_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct TrackVisionTarget_SendGoal_Response_

// alias to use template instance with default allocator
using TrackVisionTarget_SendGoal_Response =
  kompass_interfaces::action::TrackVisionTarget_SendGoal_Response_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace kompass_interfaces

namespace kompass_interfaces
{

namespace action
{

struct TrackVisionTarget_SendGoal
{
  using Request = kompass_interfaces::action::TrackVisionTarget_SendGoal_Request;
  using Response = kompass_interfaces::action::TrackVisionTarget_SendGoal_Response;
};

}  // namespace action

}  // namespace kompass_interfaces


// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__kompass_interfaces__action__TrackVisionTarget_GetResult_Request __attribute__((deprecated))
#else
# define DEPRECATED__kompass_interfaces__action__TrackVisionTarget_GetResult_Request __declspec(deprecated)
#endif

namespace kompass_interfaces
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct TrackVisionTarget_GetResult_Request_
{
  using Type = TrackVisionTarget_GetResult_Request_<ContainerAllocator>;

  explicit TrackVisionTarget_GetResult_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_init)
  {
    (void)_init;
  }

  explicit TrackVisionTarget_GetResult_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _goal_id_type =
    unique_identifier_msgs::msg::UUID_<ContainerAllocator>;
  _goal_id_type goal_id;

  // setters for named parameter idiom
  Type & set__goal_id(
    const unique_identifier_msgs::msg::UUID_<ContainerAllocator> & _arg)
  {
    this->goal_id = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    kompass_interfaces::action::TrackVisionTarget_GetResult_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const kompass_interfaces::action::TrackVisionTarget_GetResult_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<kompass_interfaces::action::TrackVisionTarget_GetResult_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<kompass_interfaces::action::TrackVisionTarget_GetResult_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::TrackVisionTarget_GetResult_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::TrackVisionTarget_GetResult_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::TrackVisionTarget_GetResult_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::TrackVisionTarget_GetResult_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<kompass_interfaces::action::TrackVisionTarget_GetResult_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<kompass_interfaces::action::TrackVisionTarget_GetResult_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__kompass_interfaces__action__TrackVisionTarget_GetResult_Request
    std::shared_ptr<kompass_interfaces::action::TrackVisionTarget_GetResult_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__kompass_interfaces__action__TrackVisionTarget_GetResult_Request
    std::shared_ptr<kompass_interfaces::action::TrackVisionTarget_GetResult_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const TrackVisionTarget_GetResult_Request_ & other) const
  {
    if (this->goal_id != other.goal_id) {
      return false;
    }
    return true;
  }
  bool operator!=(const TrackVisionTarget_GetResult_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct TrackVisionTarget_GetResult_Request_

// alias to use template instance with default allocator
using TrackVisionTarget_GetResult_Request =
  kompass_interfaces::action::TrackVisionTarget_GetResult_Request_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace kompass_interfaces


// Include directives for member types
// Member 'result'
// already included above
// #include "kompass_interfaces/action/detail/track_vision_target__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__kompass_interfaces__action__TrackVisionTarget_GetResult_Response __attribute__((deprecated))
#else
# define DEPRECATED__kompass_interfaces__action__TrackVisionTarget_GetResult_Response __declspec(deprecated)
#endif

namespace kompass_interfaces
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct TrackVisionTarget_GetResult_Response_
{
  using Type = TrackVisionTarget_GetResult_Response_<ContainerAllocator>;

  explicit TrackVisionTarget_GetResult_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : result(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->status = 0;
    }
  }

  explicit TrackVisionTarget_GetResult_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : result(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->status = 0;
    }
  }

  // field types and members
  using _status_type =
    int8_t;
  _status_type status;
  using _result_type =
    kompass_interfaces::action::TrackVisionTarget_Result_<ContainerAllocator>;
  _result_type result;

  // setters for named parameter idiom
  Type & set__status(
    const int8_t & _arg)
  {
    this->status = _arg;
    return *this;
  }
  Type & set__result(
    const kompass_interfaces::action::TrackVisionTarget_Result_<ContainerAllocator> & _arg)
  {
    this->result = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    kompass_interfaces::action::TrackVisionTarget_GetResult_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const kompass_interfaces::action::TrackVisionTarget_GetResult_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<kompass_interfaces::action::TrackVisionTarget_GetResult_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<kompass_interfaces::action::TrackVisionTarget_GetResult_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::TrackVisionTarget_GetResult_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::TrackVisionTarget_GetResult_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::TrackVisionTarget_GetResult_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::TrackVisionTarget_GetResult_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<kompass_interfaces::action::TrackVisionTarget_GetResult_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<kompass_interfaces::action::TrackVisionTarget_GetResult_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__kompass_interfaces__action__TrackVisionTarget_GetResult_Response
    std::shared_ptr<kompass_interfaces::action::TrackVisionTarget_GetResult_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__kompass_interfaces__action__TrackVisionTarget_GetResult_Response
    std::shared_ptr<kompass_interfaces::action::TrackVisionTarget_GetResult_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const TrackVisionTarget_GetResult_Response_ & other) const
  {
    if (this->status != other.status) {
      return false;
    }
    if (this->result != other.result) {
      return false;
    }
    return true;
  }
  bool operator!=(const TrackVisionTarget_GetResult_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct TrackVisionTarget_GetResult_Response_

// alias to use template instance with default allocator
using TrackVisionTarget_GetResult_Response =
  kompass_interfaces::action::TrackVisionTarget_GetResult_Response_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace kompass_interfaces

namespace kompass_interfaces
{

namespace action
{

struct TrackVisionTarget_GetResult
{
  using Request = kompass_interfaces::action::TrackVisionTarget_GetResult_Request;
  using Response = kompass_interfaces::action::TrackVisionTarget_GetResult_Response;
};

}  // namespace action

}  // namespace kompass_interfaces


// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__struct.hpp"
// Member 'feedback'
// already included above
// #include "kompass_interfaces/action/detail/track_vision_target__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__kompass_interfaces__action__TrackVisionTarget_FeedbackMessage __attribute__((deprecated))
#else
# define DEPRECATED__kompass_interfaces__action__TrackVisionTarget_FeedbackMessage __declspec(deprecated)
#endif

namespace kompass_interfaces
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct TrackVisionTarget_FeedbackMessage_
{
  using Type = TrackVisionTarget_FeedbackMessage_<ContainerAllocator>;

  explicit TrackVisionTarget_FeedbackMessage_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_init),
    feedback(_init)
  {
    (void)_init;
  }

  explicit TrackVisionTarget_FeedbackMessage_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_alloc, _init),
    feedback(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _goal_id_type =
    unique_identifier_msgs::msg::UUID_<ContainerAllocator>;
  _goal_id_type goal_id;
  using _feedback_type =
    kompass_interfaces::action::TrackVisionTarget_Feedback_<ContainerAllocator>;
  _feedback_type feedback;

  // setters for named parameter idiom
  Type & set__goal_id(
    const unique_identifier_msgs::msg::UUID_<ContainerAllocator> & _arg)
  {
    this->goal_id = _arg;
    return *this;
  }
  Type & set__feedback(
    const kompass_interfaces::action::TrackVisionTarget_Feedback_<ContainerAllocator> & _arg)
  {
    this->feedback = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    kompass_interfaces::action::TrackVisionTarget_FeedbackMessage_<ContainerAllocator> *;
  using ConstRawPtr =
    const kompass_interfaces::action::TrackVisionTarget_FeedbackMessage_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<kompass_interfaces::action::TrackVisionTarget_FeedbackMessage_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<kompass_interfaces::action::TrackVisionTarget_FeedbackMessage_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::TrackVisionTarget_FeedbackMessage_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::TrackVisionTarget_FeedbackMessage_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::TrackVisionTarget_FeedbackMessage_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::TrackVisionTarget_FeedbackMessage_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<kompass_interfaces::action::TrackVisionTarget_FeedbackMessage_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<kompass_interfaces::action::TrackVisionTarget_FeedbackMessage_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__kompass_interfaces__action__TrackVisionTarget_FeedbackMessage
    std::shared_ptr<kompass_interfaces::action::TrackVisionTarget_FeedbackMessage_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__kompass_interfaces__action__TrackVisionTarget_FeedbackMessage
    std::shared_ptr<kompass_interfaces::action::TrackVisionTarget_FeedbackMessage_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const TrackVisionTarget_FeedbackMessage_ & other) const
  {
    if (this->goal_id != other.goal_id) {
      return false;
    }
    if (this->feedback != other.feedback) {
      return false;
    }
    return true;
  }
  bool operator!=(const TrackVisionTarget_FeedbackMessage_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct TrackVisionTarget_FeedbackMessage_

// alias to use template instance with default allocator
using TrackVisionTarget_FeedbackMessage =
  kompass_interfaces::action::TrackVisionTarget_FeedbackMessage_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace kompass_interfaces

#include "action_msgs/srv/cancel_goal.hpp"
#include "action_msgs/msg/goal_info.hpp"
#include "action_msgs/msg/goal_status_array.hpp"

namespace kompass_interfaces
{

namespace action
{

struct TrackVisionTarget
{
  /// The goal message defined in the action definition.
  using Goal = kompass_interfaces::action::TrackVisionTarget_Goal;
  /// The result message defined in the action definition.
  using Result = kompass_interfaces::action::TrackVisionTarget_Result;
  /// The feedback message defined in the action definition.
  using Feedback = kompass_interfaces::action::TrackVisionTarget_Feedback;

  struct Impl
  {
    /// The send_goal service using a wrapped version of the goal message as a request.
    using SendGoalService = kompass_interfaces::action::TrackVisionTarget_SendGoal;
    /// The get_result service using a wrapped version of the result message as a response.
    using GetResultService = kompass_interfaces::action::TrackVisionTarget_GetResult;
    /// The feedback message with generic fields which wraps the feedback message.
    using FeedbackMessage = kompass_interfaces::action::TrackVisionTarget_FeedbackMessage;

    /// The generic service to cancel a goal.
    using CancelGoalService = action_msgs::srv::CancelGoal;
    /// The generic message for the status of a goal.
    using GoalStatusMessage = action_msgs::msg::GoalStatusArray;
  };
};

typedef struct TrackVisionTarget TrackVisionTarget;

}  // namespace action

}  // namespace kompass_interfaces

#endif  // KOMPASS_INTERFACES__ACTION__DETAIL__TRACK_VISION_TARGET__STRUCT_HPP_
