// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from kompass_interfaces:msg/MotionStatus.idl
// generated code does not contain a copyright notice

#ifndef KOMPASS_INTERFACES__MSG__DETAIL__MOTION_STATUS__STRUCT_H_
#define KOMPASS_INTERFACES__MSG__DETAIL__MOTION_STATUS__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'STATUS_HEALTHY'.
/**
  * MOTION COMMANDS ARE GETTING PUBLISHED AND EXECUTED BY THE ROBOT
 */
enum
{
  kompass_interfaces__msg__MotionStatus__STATUS_HEALTHY = 0
};

/// Constant 'STATUS_FREEZING_ROBOT'.
/**
  * PHYSICAL OBSTACLE IS BLOCKING THE ROBOT WAY AND THE ROBOT IS FROSEN
 */
enum
{
  kompass_interfaces__msg__MotionStatus__STATUS_FREEZING_ROBOT = 1
};

/// Constant 'STATUS_LOW_LEVEL_ERROR'.
/**
  * ROBOT IS NOT MOVING WHILE THE MANAGER IS SENDING VELOCITY COMMANDS AND THERE IS NO PHYSICAL OBSTACLE
 */
enum
{
  kompass_interfaces__msg__MotionStatus__STATUS_LOW_LEVEL_ERROR = 2
};

/// Constant 'STATUS_CONTROLLER_ERROR'.
/**
  * CONTROLLER IS NOT SENDING VELOCITY COMMANDS
 */
enum
{
  kompass_interfaces__msg__MotionStatus__STATUS_CONTROLLER_ERROR = 3
};

/// Constant 'STATUS_PATH_FOLLOWER_ERROR'.
/**
  * PATH FOLLOWER IS NOT SENDING REFERENCE PATH COMMANDS
 */
enum
{
  kompass_interfaces__msg__MotionStatus__STATUS_PATH_FOLLOWER_ERROR = 4
};

/// Constant 'STATUS_ODOMETRY_NOT_RECEIVED'.
/**
  * STACK NOT GETTING ROBOT ODOMETRY
 */
enum
{
  kompass_interfaces__msg__MotionStatus__STATUS_ODOMETRY_NOT_RECEIVED = 5
};

// Include directives for member types
// Member 'message'
#include "rosidl_runtime_c/string.h"

/// Struct defined in msg/MotionStatus in the package kompass_interfaces.
typedef struct kompass_interfaces__msg__MotionStatus
{
  uint8_t status;
  rosidl_runtime_c__String message;
} kompass_interfaces__msg__MotionStatus;

// Struct for a sequence of kompass_interfaces__msg__MotionStatus.
typedef struct kompass_interfaces__msg__MotionStatus__Sequence
{
  kompass_interfaces__msg__MotionStatus * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} kompass_interfaces__msg__MotionStatus__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // KOMPASS_INTERFACES__MSG__DETAIL__MOTION_STATUS__STRUCT_H_
