// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from kompass_interfaces:msg/Obstacles.idl
// generated code does not contain a copyright notice

#ifndef KOMPASS_INTERFACES__MSG__DETAIL__OBSTACLES__STRUCT_H_
#define KOMPASS_INTERFACES__MSG__DETAIL__OBSTACLES__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"
// Member 'info'
#include "nav_msgs/msg/detail/map_meta_data__struct.h"
// Member 'obstacle_type'
// Member 'x_global'
// Member 'y_global'
// Member 'x_local'
// Member 'y_local'
// Member 'i_grid'
// Member 'j_grid'
// Member 'occupied_zone'
// Member 'class_id'
// Member 'object_id'
// Member 'vx'
// Member 'vy'
#include "rosidl_runtime_c/primitives_sequence.h"

/// Struct defined in msg/Obstacles in the package kompass_interfaces.
/**
  * This represents a multi 2-D grid map
 */
typedef struct kompass_interfaces__msg__Obstacles
{
  std_msgs__msg__Header header;
  /// MetaData for the map
  nav_msgs__msg__MapMetaData info;
  /// occupancy info
  /// 1 occupied by scan  #2 occupied by detections #3 both
  rosidl_runtime_c__int32__Sequence obstacle_type;
  rosidl_runtime_c__float__Sequence x_global;
  rosidl_runtime_c__float__Sequence y_global;
  rosidl_runtime_c__float__Sequence x_local;
  rosidl_runtime_c__float__Sequence y_local;
  rosidl_runtime_c__int32__Sequence i_grid;
  rosidl_runtime_c__int32__Sequence j_grid;
  rosidl_runtime_c__float__Sequence occupied_zone;
  /// semantic info
  rosidl_runtime_c__int32__Sequence class_id;
  ///  string[] class_name
  /// tracking info
  rosidl_runtime_c__int32__Sequence object_id;
  rosidl_runtime_c__float__Sequence vx;
  rosidl_runtime_c__float__Sequence vy;
} kompass_interfaces__msg__Obstacles;

// Struct for a sequence of kompass_interfaces__msg__Obstacles.
typedef struct kompass_interfaces__msg__Obstacles__Sequence
{
  kompass_interfaces__msg__Obstacles * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} kompass_interfaces__msg__Obstacles__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // KOMPASS_INTERFACES__MSG__DETAIL__OBSTACLES__STRUCT_H_
