// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from kompass_interfaces:msg/PathTrackingError.idl
// generated code does not contain a copyright notice
#include "kompass_interfaces/msg/detail/path_tracking_error__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


bool
kompass_interfaces__msg__PathTrackingError__init(kompass_interfaces__msg__PathTrackingError * msg)
{
  if (!msg) {
    return false;
  }
  // orientation_error
  // lateral_distance_error
  return true;
}

void
kompass_interfaces__msg__PathTrackingError__fini(kompass_interfaces__msg__PathTrackingError * msg)
{
  if (!msg) {
    return;
  }
  // orientation_error
  // lateral_distance_error
}

bool
kompass_interfaces__msg__PathTrackingError__are_equal(const kompass_interfaces__msg__PathTrackingError * lhs, const kompass_interfaces__msg__PathTrackingError * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // orientation_error
  if (lhs->orientation_error != rhs->orientation_error) {
    return false;
  }
  // lateral_distance_error
  if (lhs->lateral_distance_error != rhs->lateral_distance_error) {
    return false;
  }
  return true;
}

bool
kompass_interfaces__msg__PathTrackingError__copy(
  const kompass_interfaces__msg__PathTrackingError * input,
  kompass_interfaces__msg__PathTrackingError * output)
{
  if (!input || !output) {
    return false;
  }
  // orientation_error
  output->orientation_error = input->orientation_error;
  // lateral_distance_error
  output->lateral_distance_error = input->lateral_distance_error;
  return true;
}

kompass_interfaces__msg__PathTrackingError *
kompass_interfaces__msg__PathTrackingError__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  kompass_interfaces__msg__PathTrackingError * msg = (kompass_interfaces__msg__PathTrackingError *)allocator.allocate(sizeof(kompass_interfaces__msg__PathTrackingError), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(kompass_interfaces__msg__PathTrackingError));
  bool success = kompass_interfaces__msg__PathTrackingError__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
kompass_interfaces__msg__PathTrackingError__destroy(kompass_interfaces__msg__PathTrackingError * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    kompass_interfaces__msg__PathTrackingError__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
kompass_interfaces__msg__PathTrackingError__Sequence__init(kompass_interfaces__msg__PathTrackingError__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  kompass_interfaces__msg__PathTrackingError * data = NULL;

  if (size) {
    data = (kompass_interfaces__msg__PathTrackingError *)allocator.zero_allocate(size, sizeof(kompass_interfaces__msg__PathTrackingError), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = kompass_interfaces__msg__PathTrackingError__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        kompass_interfaces__msg__PathTrackingError__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
kompass_interfaces__msg__PathTrackingError__Sequence__fini(kompass_interfaces__msg__PathTrackingError__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      kompass_interfaces__msg__PathTrackingError__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

kompass_interfaces__msg__PathTrackingError__Sequence *
kompass_interfaces__msg__PathTrackingError__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  kompass_interfaces__msg__PathTrackingError__Sequence * array = (kompass_interfaces__msg__PathTrackingError__Sequence *)allocator.allocate(sizeof(kompass_interfaces__msg__PathTrackingError__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = kompass_interfaces__msg__PathTrackingError__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
kompass_interfaces__msg__PathTrackingError__Sequence__destroy(kompass_interfaces__msg__PathTrackingError__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    kompass_interfaces__msg__PathTrackingError__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
kompass_interfaces__msg__PathTrackingError__Sequence__are_equal(const kompass_interfaces__msg__PathTrackingError__Sequence * lhs, const kompass_interfaces__msg__PathTrackingError__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!kompass_interfaces__msg__PathTrackingError__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
kompass_interfaces__msg__PathTrackingError__Sequence__copy(
  const kompass_interfaces__msg__PathTrackingError__Sequence * input,
  kompass_interfaces__msg__PathTrackingError__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(kompass_interfaces__msg__PathTrackingError);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    kompass_interfaces__msg__PathTrackingError * data =
      (kompass_interfaces__msg__PathTrackingError *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!kompass_interfaces__msg__PathTrackingError__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          kompass_interfaces__msg__PathTrackingError__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!kompass_interfaces__msg__PathTrackingError__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
