// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from kompass_interfaces:srv/GetPredictedOccupancies.idl
// generated code does not contain a copyright notice
#include "kompass_interfaces/srv/detail/get_predicted_occupancies__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"

// Include directives for member types
// Member `prediction_model_type`
#include "rosidl_runtime_c/string_functions.h"

bool
kompass_interfaces__srv__GetPredictedOccupancies_Request__init(kompass_interfaces__srv__GetPredictedOccupancies_Request * msg)
{
  if (!msg) {
    return false;
  }
  // start_time
  // horizon
  // time_step
  // prediction_model_type
  if (!rosidl_runtime_c__String__init(&msg->prediction_model_type)) {
    kompass_interfaces__srv__GetPredictedOccupancies_Request__fini(msg);
    return false;
  }
  return true;
}

void
kompass_interfaces__srv__GetPredictedOccupancies_Request__fini(kompass_interfaces__srv__GetPredictedOccupancies_Request * msg)
{
  if (!msg) {
    return;
  }
  // start_time
  // horizon
  // time_step
  // prediction_model_type
  rosidl_runtime_c__String__fini(&msg->prediction_model_type);
}

bool
kompass_interfaces__srv__GetPredictedOccupancies_Request__are_equal(const kompass_interfaces__srv__GetPredictedOccupancies_Request * lhs, const kompass_interfaces__srv__GetPredictedOccupancies_Request * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // start_time
  if (lhs->start_time != rhs->start_time) {
    return false;
  }
  // horizon
  if (lhs->horizon != rhs->horizon) {
    return false;
  }
  // time_step
  if (lhs->time_step != rhs->time_step) {
    return false;
  }
  // prediction_model_type
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->prediction_model_type), &(rhs->prediction_model_type)))
  {
    return false;
  }
  return true;
}

bool
kompass_interfaces__srv__GetPredictedOccupancies_Request__copy(
  const kompass_interfaces__srv__GetPredictedOccupancies_Request * input,
  kompass_interfaces__srv__GetPredictedOccupancies_Request * output)
{
  if (!input || !output) {
    return false;
  }
  // start_time
  output->start_time = input->start_time;
  // horizon
  output->horizon = input->horizon;
  // time_step
  output->time_step = input->time_step;
  // prediction_model_type
  if (!rosidl_runtime_c__String__copy(
      &(input->prediction_model_type), &(output->prediction_model_type)))
  {
    return false;
  }
  return true;
}

kompass_interfaces__srv__GetPredictedOccupancies_Request *
kompass_interfaces__srv__GetPredictedOccupancies_Request__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  kompass_interfaces__srv__GetPredictedOccupancies_Request * msg = (kompass_interfaces__srv__GetPredictedOccupancies_Request *)allocator.allocate(sizeof(kompass_interfaces__srv__GetPredictedOccupancies_Request), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(kompass_interfaces__srv__GetPredictedOccupancies_Request));
  bool success = kompass_interfaces__srv__GetPredictedOccupancies_Request__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
kompass_interfaces__srv__GetPredictedOccupancies_Request__destroy(kompass_interfaces__srv__GetPredictedOccupancies_Request * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    kompass_interfaces__srv__GetPredictedOccupancies_Request__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
kompass_interfaces__srv__GetPredictedOccupancies_Request__Sequence__init(kompass_interfaces__srv__GetPredictedOccupancies_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  kompass_interfaces__srv__GetPredictedOccupancies_Request * data = NULL;

  if (size) {
    data = (kompass_interfaces__srv__GetPredictedOccupancies_Request *)allocator.zero_allocate(size, sizeof(kompass_interfaces__srv__GetPredictedOccupancies_Request), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = kompass_interfaces__srv__GetPredictedOccupancies_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        kompass_interfaces__srv__GetPredictedOccupancies_Request__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
kompass_interfaces__srv__GetPredictedOccupancies_Request__Sequence__fini(kompass_interfaces__srv__GetPredictedOccupancies_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      kompass_interfaces__srv__GetPredictedOccupancies_Request__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

kompass_interfaces__srv__GetPredictedOccupancies_Request__Sequence *
kompass_interfaces__srv__GetPredictedOccupancies_Request__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  kompass_interfaces__srv__GetPredictedOccupancies_Request__Sequence * array = (kompass_interfaces__srv__GetPredictedOccupancies_Request__Sequence *)allocator.allocate(sizeof(kompass_interfaces__srv__GetPredictedOccupancies_Request__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = kompass_interfaces__srv__GetPredictedOccupancies_Request__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
kompass_interfaces__srv__GetPredictedOccupancies_Request__Sequence__destroy(kompass_interfaces__srv__GetPredictedOccupancies_Request__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    kompass_interfaces__srv__GetPredictedOccupancies_Request__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
kompass_interfaces__srv__GetPredictedOccupancies_Request__Sequence__are_equal(const kompass_interfaces__srv__GetPredictedOccupancies_Request__Sequence * lhs, const kompass_interfaces__srv__GetPredictedOccupancies_Request__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!kompass_interfaces__srv__GetPredictedOccupancies_Request__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
kompass_interfaces__srv__GetPredictedOccupancies_Request__Sequence__copy(
  const kompass_interfaces__srv__GetPredictedOccupancies_Request__Sequence * input,
  kompass_interfaces__srv__GetPredictedOccupancies_Request__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(kompass_interfaces__srv__GetPredictedOccupancies_Request);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    kompass_interfaces__srv__GetPredictedOccupancies_Request * data =
      (kompass_interfaces__srv__GetPredictedOccupancies_Request *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!kompass_interfaces__srv__GetPredictedOccupancies_Request__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          kompass_interfaces__srv__GetPredictedOccupancies_Request__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!kompass_interfaces__srv__GetPredictedOccupancies_Request__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `predicted_occupancies_topic_name`
// already included above
// #include "rosidl_runtime_c/string_functions.h"

bool
kompass_interfaces__srv__GetPredictedOccupancies_Response__init(kompass_interfaces__srv__GetPredictedOccupancies_Response * msg)
{
  if (!msg) {
    return false;
  }
  // prediction_completed
  // predicted_occupancies_topic_name
  if (!rosidl_runtime_c__String__init(&msg->predicted_occupancies_topic_name)) {
    kompass_interfaces__srv__GetPredictedOccupancies_Response__fini(msg);
    return false;
  }
  return true;
}

void
kompass_interfaces__srv__GetPredictedOccupancies_Response__fini(kompass_interfaces__srv__GetPredictedOccupancies_Response * msg)
{
  if (!msg) {
    return;
  }
  // prediction_completed
  // predicted_occupancies_topic_name
  rosidl_runtime_c__String__fini(&msg->predicted_occupancies_topic_name);
}

bool
kompass_interfaces__srv__GetPredictedOccupancies_Response__are_equal(const kompass_interfaces__srv__GetPredictedOccupancies_Response * lhs, const kompass_interfaces__srv__GetPredictedOccupancies_Response * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // prediction_completed
  if (lhs->prediction_completed != rhs->prediction_completed) {
    return false;
  }
  // predicted_occupancies_topic_name
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->predicted_occupancies_topic_name), &(rhs->predicted_occupancies_topic_name)))
  {
    return false;
  }
  return true;
}

bool
kompass_interfaces__srv__GetPredictedOccupancies_Response__copy(
  const kompass_interfaces__srv__GetPredictedOccupancies_Response * input,
  kompass_interfaces__srv__GetPredictedOccupancies_Response * output)
{
  if (!input || !output) {
    return false;
  }
  // prediction_completed
  output->prediction_completed = input->prediction_completed;
  // predicted_occupancies_topic_name
  if (!rosidl_runtime_c__String__copy(
      &(input->predicted_occupancies_topic_name), &(output->predicted_occupancies_topic_name)))
  {
    return false;
  }
  return true;
}

kompass_interfaces__srv__GetPredictedOccupancies_Response *
kompass_interfaces__srv__GetPredictedOccupancies_Response__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  kompass_interfaces__srv__GetPredictedOccupancies_Response * msg = (kompass_interfaces__srv__GetPredictedOccupancies_Response *)allocator.allocate(sizeof(kompass_interfaces__srv__GetPredictedOccupancies_Response), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(kompass_interfaces__srv__GetPredictedOccupancies_Response));
  bool success = kompass_interfaces__srv__GetPredictedOccupancies_Response__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
kompass_interfaces__srv__GetPredictedOccupancies_Response__destroy(kompass_interfaces__srv__GetPredictedOccupancies_Response * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    kompass_interfaces__srv__GetPredictedOccupancies_Response__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
kompass_interfaces__srv__GetPredictedOccupancies_Response__Sequence__init(kompass_interfaces__srv__GetPredictedOccupancies_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  kompass_interfaces__srv__GetPredictedOccupancies_Response * data = NULL;

  if (size) {
    data = (kompass_interfaces__srv__GetPredictedOccupancies_Response *)allocator.zero_allocate(size, sizeof(kompass_interfaces__srv__GetPredictedOccupancies_Response), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = kompass_interfaces__srv__GetPredictedOccupancies_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        kompass_interfaces__srv__GetPredictedOccupancies_Response__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
kompass_interfaces__srv__GetPredictedOccupancies_Response__Sequence__fini(kompass_interfaces__srv__GetPredictedOccupancies_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      kompass_interfaces__srv__GetPredictedOccupancies_Response__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

kompass_interfaces__srv__GetPredictedOccupancies_Response__Sequence *
kompass_interfaces__srv__GetPredictedOccupancies_Response__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  kompass_interfaces__srv__GetPredictedOccupancies_Response__Sequence * array = (kompass_interfaces__srv__GetPredictedOccupancies_Response__Sequence *)allocator.allocate(sizeof(kompass_interfaces__srv__GetPredictedOccupancies_Response__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = kompass_interfaces__srv__GetPredictedOccupancies_Response__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
kompass_interfaces__srv__GetPredictedOccupancies_Response__Sequence__destroy(kompass_interfaces__srv__GetPredictedOccupancies_Response__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    kompass_interfaces__srv__GetPredictedOccupancies_Response__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
kompass_interfaces__srv__GetPredictedOccupancies_Response__Sequence__are_equal(const kompass_interfaces__srv__GetPredictedOccupancies_Response__Sequence * lhs, const kompass_interfaces__srv__GetPredictedOccupancies_Response__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!kompass_interfaces__srv__GetPredictedOccupancies_Response__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
kompass_interfaces__srv__GetPredictedOccupancies_Response__Sequence__copy(
  const kompass_interfaces__srv__GetPredictedOccupancies_Response__Sequence * input,
  kompass_interfaces__srv__GetPredictedOccupancies_Response__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(kompass_interfaces__srv__GetPredictedOccupancies_Response);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    kompass_interfaces__srv__GetPredictedOccupancies_Response * data =
      (kompass_interfaces__srv__GetPredictedOccupancies_Response *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!kompass_interfaces__srv__GetPredictedOccupancies_Response__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          kompass_interfaces__srv__GetPredictedOccupancies_Response__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!kompass_interfaces__srv__GetPredictedOccupancies_Response__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
