// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from kompass_interfaces:srv/GetPredictedOccupancies.idl
// generated code does not contain a copyright notice

#ifndef KOMPASS_INTERFACES__SRV__DETAIL__GET_PREDICTED_OCCUPANCIES__STRUCT_HPP_
#define KOMPASS_INTERFACES__SRV__DETAIL__GET_PREDICTED_OCCUPANCIES__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__kompass_interfaces__srv__GetPredictedOccupancies_Request __attribute__((deprecated))
#else
# define DEPRECATED__kompass_interfaces__srv__GetPredictedOccupancies_Request __declspec(deprecated)
#endif

namespace kompass_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct GetPredictedOccupancies_Request_
{
  using Type = GetPredictedOccupancies_Request_<ContainerAllocator>;

  explicit GetPredictedOccupancies_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->start_time = 0.0f;
      this->horizon = 0.0f;
      this->time_step = 0.0f;
      this->prediction_model_type = "";
    }
  }

  explicit GetPredictedOccupancies_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : prediction_model_type(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->start_time = 0.0f;
      this->horizon = 0.0f;
      this->time_step = 0.0f;
      this->prediction_model_type = "";
    }
  }

  // field types and members
  using _start_time_type =
    float;
  _start_time_type start_time;
  using _horizon_type =
    float;
  _horizon_type horizon;
  using _time_step_type =
    float;
  _time_step_type time_step;
  using _prediction_model_type_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _prediction_model_type_type prediction_model_type;

  // setters for named parameter idiom
  Type & set__start_time(
    const float & _arg)
  {
    this->start_time = _arg;
    return *this;
  }
  Type & set__horizon(
    const float & _arg)
  {
    this->horizon = _arg;
    return *this;
  }
  Type & set__time_step(
    const float & _arg)
  {
    this->time_step = _arg;
    return *this;
  }
  Type & set__prediction_model_type(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->prediction_model_type = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    kompass_interfaces::srv::GetPredictedOccupancies_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const kompass_interfaces::srv::GetPredictedOccupancies_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<kompass_interfaces::srv::GetPredictedOccupancies_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<kompass_interfaces::srv::GetPredictedOccupancies_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::srv::GetPredictedOccupancies_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::srv::GetPredictedOccupancies_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::srv::GetPredictedOccupancies_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::srv::GetPredictedOccupancies_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<kompass_interfaces::srv::GetPredictedOccupancies_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<kompass_interfaces::srv::GetPredictedOccupancies_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__kompass_interfaces__srv__GetPredictedOccupancies_Request
    std::shared_ptr<kompass_interfaces::srv::GetPredictedOccupancies_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__kompass_interfaces__srv__GetPredictedOccupancies_Request
    std::shared_ptr<kompass_interfaces::srv::GetPredictedOccupancies_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GetPredictedOccupancies_Request_ & other) const
  {
    if (this->start_time != other.start_time) {
      return false;
    }
    if (this->horizon != other.horizon) {
      return false;
    }
    if (this->time_step != other.time_step) {
      return false;
    }
    if (this->prediction_model_type != other.prediction_model_type) {
      return false;
    }
    return true;
  }
  bool operator!=(const GetPredictedOccupancies_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GetPredictedOccupancies_Request_

// alias to use template instance with default allocator
using GetPredictedOccupancies_Request =
  kompass_interfaces::srv::GetPredictedOccupancies_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace kompass_interfaces


#ifndef _WIN32
# define DEPRECATED__kompass_interfaces__srv__GetPredictedOccupancies_Response __attribute__((deprecated))
#else
# define DEPRECATED__kompass_interfaces__srv__GetPredictedOccupancies_Response __declspec(deprecated)
#endif

namespace kompass_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct GetPredictedOccupancies_Response_
{
  using Type = GetPredictedOccupancies_Response_<ContainerAllocator>;

  explicit GetPredictedOccupancies_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->prediction_completed = false;
      this->predicted_occupancies_topic_name = "";
    }
  }

  explicit GetPredictedOccupancies_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : predicted_occupancies_topic_name(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->prediction_completed = false;
      this->predicted_occupancies_topic_name = "";
    }
  }

  // field types and members
  using _prediction_completed_type =
    bool;
  _prediction_completed_type prediction_completed;
  using _predicted_occupancies_topic_name_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _predicted_occupancies_topic_name_type predicted_occupancies_topic_name;

  // setters for named parameter idiom
  Type & set__prediction_completed(
    const bool & _arg)
  {
    this->prediction_completed = _arg;
    return *this;
  }
  Type & set__predicted_occupancies_topic_name(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->predicted_occupancies_topic_name = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    kompass_interfaces::srv::GetPredictedOccupancies_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const kompass_interfaces::srv::GetPredictedOccupancies_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<kompass_interfaces::srv::GetPredictedOccupancies_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<kompass_interfaces::srv::GetPredictedOccupancies_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::srv::GetPredictedOccupancies_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::srv::GetPredictedOccupancies_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::srv::GetPredictedOccupancies_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::srv::GetPredictedOccupancies_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<kompass_interfaces::srv::GetPredictedOccupancies_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<kompass_interfaces::srv::GetPredictedOccupancies_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__kompass_interfaces__srv__GetPredictedOccupancies_Response
    std::shared_ptr<kompass_interfaces::srv::GetPredictedOccupancies_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__kompass_interfaces__srv__GetPredictedOccupancies_Response
    std::shared_ptr<kompass_interfaces::srv::GetPredictedOccupancies_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GetPredictedOccupancies_Response_ & other) const
  {
    if (this->prediction_completed != other.prediction_completed) {
      return false;
    }
    if (this->predicted_occupancies_topic_name != other.predicted_occupancies_topic_name) {
      return false;
    }
    return true;
  }
  bool operator!=(const GetPredictedOccupancies_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GetPredictedOccupancies_Response_

// alias to use template instance with default allocator
using GetPredictedOccupancies_Response =
  kompass_interfaces::srv::GetPredictedOccupancies_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace kompass_interfaces

namespace kompass_interfaces
{

namespace srv
{

struct GetPredictedOccupancies
{
  using Request = kompass_interfaces::srv::GetPredictedOccupancies_Request;
  using Response = kompass_interfaces::srv::GetPredictedOccupancies_Response;
};

}  // namespace srv

}  // namespace kompass_interfaces

#endif  // KOMPASS_INTERFACES__SRV__DETAIL__GET_PREDICTED_OCCUPANCIES__STRUCT_HPP_
